#!/bin/csh -f
# install.com
#-----------------------------------------------------------------------
#
# Change Log:
# 21-Jan-08 CGENFF added to FULL - KEVO
# 15-Aug-07 fix allows both 32-bit and 64-bit (x86_64) PGI, PathScale
#           PGI now pgf95 instead of pgf77
#           Unused (in any C code) -Dnographics flag removed
# 15-Aug-06 FEWMFC, PBCUBES, PROTO, SMD, TAMD keys added
#           FORTRAN90 compilation updated
#           Dynamic link and MODPREF added
#           gfortran is the default gnu compiler.
# 15-Feb-06 GFORTRAN, X86_64 switch added
#           itanium, em64t, xlf95, mpif90 sections added
#           SQUANTUM installation added
#           ENSEMBLE installation modified
# 15-Aug-05 MNDO97 interfaced. Use W to replace QUANTUM.
# 15-Feb-05 HUGE, XLARGE implemented
#           New feature keys, FIRCHG, SLVSLV, LNTAB1, WCA added to pref.dat
#           SOCKET compilation fixed
# 15-Aug-04 Obsolete platforms cm5, convex, cray, cray_f90, cspp, dec, gws
#           ibmrs, ibmsp, ibmsp3, intel, stardent, t3d and terra removed.
#           EXPAND is default
#           AR_COMMAND macro added
#           64-bit IBM/AIX support
# 15-FEB-04 Added ASPMEMB, CHEQ, DYNVV2, EMAP, GBIM, LRVDW, OVERLAP,
#           SCPISM and TESTENDIAN to the FULL version
#           Added OSX, EFC(GNU) and Altix support - RG, SRB, MFC, CLB
#           QQCHEM switch added
#           VECTOR, CRAYVEC, PARVECT supports removed
# 15-Aug-03 GAMESS-UK interface updated, i8 support - PS
#           SUN64 port - BC
# 15-FEB-03 IFC switch added - SRB
#           LAMMPI libraries updated to circa 6.5.6 - SRB
#           Fix to support multiple MPI libraries - SRB
#           IBMAIX switches added - MFC
#           CHEQ processing added
# 15-AUG-02 SUN MPI port - RS
#           SCCDFTB switch added - QC
#           EMAP code processing added
# 15-FEB-01 IBMSP3 port and NOLOG switch added - CLB
#           g77 and pgf77 MPI modified - BW
#           Size XXLARGE added - MH
#           PSSP added to FULL version - SB
# 19-Jul-00 Added GAMESS-UK interfacing - PS
# 14-Jul-00 Fixes for CADPAC with MPI, gnu and sgi64 - BW
#           FORT switch added for compilation under Alpha Linux with
#                Compaq compilers - BW
#           FLUCQ key added - BW
# 15-Feb-99 c27a2 installation
#           sgi64 added to maintain both sgi and sgi64
#           MBO(N)D GNU port added
#           g77/f77/fort77 compilation switch modified
# 15-Sep-98 c27a0 installation
#           setenv MAKE_COMMAND for Cray T3E
#           adumb.mk, cff.mk, mc.mk and shapes.mk added
# 15-Aug-97 c25b1/c26a1 installation
#           Default feature keys are grouped into FULL and LITE for release
#           MBO(N)D key is implemented - RN
#           GAMESS modifications + GNU support for 3 compilers - MH
# 15-FEB-97 c25a3 installation
#           CADPAC jey is implemented - PL
# 15-Aug-96 c25a2 installation
#           GAMESS and PARALLEL installation added
#           POLAR key added
# 15-Feb-96 c24b2 installation
#           Alpha-MP port added
#           MMFF and PBEQ added
# 15-Aug-95 c24b1 installation
#           install switches are upgraded
#           ibmsp, intel, mpi, terra and GNU ports added
# 15-Feb-95 t3d, cspp, cm5 ports added
# 10-Feb-94 executable name charmm replaces the previous version
#             specific charmm{nn}
# 05-Feb-94 CHARMM 24a1 installation
#           main changed to charmm
# 15-Jan-94 CHARMM 23f3 installation
#           flexfort removed and new prefx.f from NIH used
#           add X and stopmark switches
# 24-Jul-93 DEC ALPHA and DEC Ultrix ports added.
#           The installation procedure is modified to use build/UNX
#           for generic UNIX platforms.
# 21-Feb-93 CHARMM 23 (c23f) installation
# 08-Oct-92 HP-UX support added.
#
# 01-Jan-92 CHARMM 22 Installation Script
#           File lists are constructed from the source directory
#           listing.  pref.dat file can be constructed interactively.
#           Some features are from Stephen H. Fleischman's build scripts.
# 15-Sep-91 CHARMM 22.0.b1 Installation Script
#           add IBM RS/6000, Stardent and Cray Y-MP support
#           testing script is separated out.
# 05-May-91 CHARMM 22.0.b Installation Script
#           Convex, SGI Irix and SUN are supported.
#
# Inquiries to chmgr@tammy.harvard.edu (617)495-4102
#-----------------------------------------------------------------------
#
# Shell variables
#RHS sunmpi added
# chm_host  = ( alpha, alphamp, altix, gnu, hpitanium, hpux   ) = $argv[1]
#             ( ibmaix, ibmaixmp, osx, sgi, sgi64, sun, sun64 )
#             ( sunmpi, t3e, itanium, em64t                   )
# chm_size  = ( huge, xxlarge, xlarge, large, medium, small, 
#                                              xsmall, reduce ) = $argv[2]
#
#-----------------------------------------------------------------------
#
date
#
phase1:
# install.com command line argument processing
# get host-mahchine-type and CHARMM size to be installed.
#
set chm_size = medium
set xreq = 0
set nodsp = 0
set pvmset = 0
set mpiset = 0
set ensemble = 0
set mpich = 0
set lammpi = 0
set mpispecial = 0
set stopmark = 0
set ibm64 = 0
set sgi64 = 0
set qgamess = 0
set qgamessuk = 0
set qcadpac = 0
set qmndo97 = 0
set qqchem = 0
set qsccdftb = 0
set qsquantm = 0
set apbs = 0
set scali = 0
set socket = 0
set f77 = 0
set f2c = 0
set g77 = 0
set xlf95 = 0
set osx = 0
set ifc = 0
set efc = 0
set amd64 = 0
set x86_64 = 0
set gfortran = 0
set pathscale = 0
set ifort = 0
set g95 = 0
set pgf95 = 0
set cfort = 0
set f90 = 0
set rng = 0
set nih = 0
set tsri = 0
set polyrate = 0
set full = 1
set longint = 0
set itanium = 0
set DEBUG = 0
# PJ 06/2005
set qpipf = 0

# MF 03/2006
set dynamic = 0
# automatic modification of pref.dat
set addprefdat = ()
set delprefdat = ()
#

if ( $#argv == 0 ) then
  echo " "
  echo " Usage: install.com host-machine-type [charmm-size] [Sw] "
  echo " "
  echo "       [1] host-machine-type is one of the following."
  echo "               alpha     DEC 3000 AXP 500"
  echo "               alphamp   DEC Alpha-MP parallel computers"
  echo "               altix     SGI Itanium Altix series (64 bit)"
  echo "               em64t     ifort compilers on em64t/xeon "
  echo "               gnu       GNU compilers"
  echo "               g95       G95 compiler"
  echo "               hal       HAL work stations"
  echo "               hpitanium HP-UX Itaniums"
  echo "               hpux      HP Apollo 9000 Series 700"
  echo "               ibmaix    IBM AIX not parallel"
  echo "               ibmaixmp  IBM AIX parallel"
  echo "               ibmlnxmp  IBM GNU/Linux parallel"
  echo "               itanium   INTEL Itanium 2 using ifort compiler"
  echo "               osx       Mac OSX machines"
  echo "               sgi       SGI IRIS series (32 bit)"
  echo "               sgi64     SGI IRIS series (64 bit)"
  echo "               sun       SUN work stations (32-bit)"
  echo "               sunmpi    SUN work stations running SUN MPI" 
  echo "               sun64     SUN work stations (64-bit)"
  echo "               t3e       Cray T3E MPP"
  echo " "
  echo "       [2] Choose [charmm-size] from {huge, xxlarge, xlarge, large, "
  echo "                                      medium, small, xsmall, reduce}."
  echo "           The default is medium."
  echo " "
  echo "       [3] [Sw] are install switches, which must be specified after"
  echo "           the size argument.  You may specify any of the following."
  echo "           X and G, P, M and E are mutually exculsive, respectively."
  echo "           MPICH, LAM and MPISPECIAL are mutually exclusive."
  echo " "
  echo "           X  include Xlib graphics, along with .ps .pov .fdat files"
  echo "      NODISP  graphics, no display; make .ps .pov .fdat files only"
  echo "           P  links to PVM"
  echo "           M  links to MPI"
  echo "           1  to halt after setting up installation directory."
  echo "           2  to halt after making installation utilities."
  echo "           64 to compile in 64-bit mode on SGI and IBM/AIX platforms."
  echo "          i8  to request 64 bit integers"
  echo "           Q  replace QUANTUM with GAMESS."
  echo "           U  replace QUANTUM with GAMESS-UK."
  echo "           C  replace QUANTUM with CADPAC."
  echo "           T  replace QUANTUM with SCCDFTB."
  echo "          QC  replace QUANTUM with Q-CHEM."
  echo "          SQ  replace QUANTUM with SQUANTUM, only with altix/gnu/ibmaix."
  echo "           W  replace QUANTUM with MNDO97, only with altix/gnu/ibmaix/sgi."
  echo "        APBS  compile with APBS support."
  echo "           S  Uses TCP/IP SOCKET library for parallel."
  echo "           E  Builds a version with ensemble replicas"
  echo "        FULL  For FULL featured version (default)."
  echo "        LITE  For a version with reduced functional features."
  echo "       XLF95  Uses xlf95/MacOSX driven by xlf95 (default is gfortran)."
  echo "         F77  Uses Absoft/Linux (default is gfortran)."
  echo "         G77  Uses obsolete GNU g77 (default is gfortran)."
  echo "         F2C  Uses f2c/Linux driven by fort77(default is gfortran)."
  echo "         IFC  Uses IA-32 Intel Fortran ifc/Linux (default is gfortran)."
  echo "         EFC  Uses IA-64 Intel Fortran efc/Linux and forces I8 (default is gfortran)."
  echo "       IFORT  Uses Intel Fortran ifort/Linux (default is gfortran)."
  echo "         G95  Uses  g95/Linux (default is gfortran)."
  echo "       PGF95  Uses PGI pgf95/Linux (default is gfortran)."
  echo "          PS  Uses PathScale Linux compiler (default is gfortran)."
  echo "        FORT  Uses Compaq ccc and fort on Alpha Linux (default is gfortran)."
  echo "    GFORTRAN  Uses extra keywords for gfortran."
  echo "      X86_64  Uses extra keywords for X86_64, both AMD64 & EM64T."
  echo "       AMD64  Uses extra keywords for g77 on AMD64."
  echo "         NIH  Uses extra keywords for NIH."
  echo "        TSRI  Uses extra keywords for TSRI."
  echo "       MPICH  adds special library options for standard MPICH."
  echo "      LAMMPI  adds special library options for standard LAM/MPI."
  echo "      SCALI   adds special library options for standard SCALI MPI Connect."
  echo "  MPISPECIAL  prompts for special MPI library options for load."
  echo "          GA  Use GA tools version of GAMESS-UK"
  echo "         RNG  Use New Random Number Generator"
  echo "           D  link dynamically (ifc/ifort)"
  echo "     MODPREF  add/remove keywords from pref.dat (w/ addtl. parameter)"
  echo "       keepf  Will keep the preprocessed .f files in build/mach."
  echo "       keepo  Will keep the preprocessed .o files in build/mach."
  echo "       DEBUG/debug Compile with debugging options to compiler (FCD)"
  echo "       big_e/little_e  Use big/little_endian binary I/O if supported by compiler"
  echo " "
  exit
#
else if ( $#argv == 1 ) then
  set chm_host = $argv[1]
else if ( $#argv == 2 ) then
  set chm_host = $argv[1]
  set chm_size = $argv[2]
else if ( $#argv >= 3 ) then
  set chm_host = $argv[1]
  set chm_size = $argv[2]
  shift
  shift
  if($chm_host == 't3e' ) set full=0
  if($chm_host == 'sun64' ) set longint = 1
  if($chm_host == 'altix' ) set longint = 1
  foreach opt ( $argv )
    if ( $opt == 'X'  ) set xreq = 1
    if ( $opt == 'P'  ) set pvmset = 1
    if ( $opt == 'M'  ) set mpiset = 1
    if ( $opt == 'E'  ) set ensemble = 1
    if ( $opt == 'D'  ) set dynamic = 1
    if ( $opt == '1'  ) set stopmark = 1
    if ( $opt == '2'  ) set stopmark = 2
    if ( $opt == '64' ) set sgi64 = 1
    if ( $opt == 'I8' || $opt == 'i8' ) set longint = 1
    if ( $opt == 'Q'  ) set qgamess = 1
    if ( $opt == 'U'  ) set qgamessuk = 1
    if ( $opt == 'C'  ) set qcadpac = 1
    if ( $opt == 'APBS' || $opt == 'apbs'  ) then
      set apbs = 1
      setenv APBS YES      
    endif     
    if ( $opt == 'S'  ) set socket = 1
    if ( $opt == 'T'  ) set qsccdftb = 1
    if ( $opt == 'QC' ) set qqchem = 1
    if ( $opt == 'SQ' ) set qsquantm = 1
    if ( $opt == 'W'  ) set qmndo97 = 1
    if ( $opt == 'FULL' || $opt == 'full' ) set full = 1
    if ( $opt == 'LITE' || $opt == 'lite' ) set full = 0
    if ( $opt == 'XLF95' || $opt == 'xlf95' ) set xlf95 = 1
    if ( $opt == 'F2C') set f2c = 1
    if ( $opt == 'F77') set f77 = 1
    if ( $opt == 'IFC' || $opt == 'ifc') set ifc = 1
    if ( $opt == 'IFORT' || $opt == 'ifort') set ifort = 1
    if ( $opt == 'G95' || $opt == 'g95') set g95 = 1
    if ( $opt == 'G77' || $opt == 'g77') set g77 = 1
    if ( $opt == 'EFC'|| $opt == 'efc' ) then
      set efc = 1
      set longint = 1
    endif
    if ( $opt == 'PGF95' || $opt == 'pgf95' ) set pgf95 = 1
    if ( $opt == 'FORT') set cfort = 1
    if ( $opt == 'F90'|| $opt == 'f90' ) set f90 = 1
    if ( $opt == 'GFORTRAN'|| $opt == 'gfortran' ) set gfortran = 1
    if ( $opt == 'X86_64'|| $opt == 'x86_64' ) set x86_64 = 1
    if ( $opt == 'AMD64'|| $opt == 'amd64' ) set amd64 = 1
    if ( $opt == 'PS'|| $opt == 'ps' ) set pathscale = 1
    if ( $opt == 'RNG'|| $opt == 'rng' ) set rng = 1
    if ( $opt == 'NIH'|| $opt == 'nih' ) set nih = 1
    if ( $opt == 'NODISP'  ) set nodsp = 1
    if ( ( $opt == 'TSRI'|| $opt == 'tsri' ) && $full == 0 ) set tsri = 1
    if ( $opt == 'big_e'|| $opt == 'BIG_E' ) set bigendian = 1
    if ( $opt == 'lit_e'|| $opt == 'LIT_E' ) set littleendian = 1
    if ( $opt == 'keepf'|| $opt == 'KEEPF' ) set keep_src
    if ( $opt == 'keepo'|| $opt == 'KEEPO' ) set keep_obj
    if ( $opt == 'debug' || $opt == 'DEBUG'  ) set DEBUG = 1
    if ( $opt == 'nolog'|| $opt == 'NOLOG' ) set nolog
    if ( $opt == 'mpich'|| $opt == 'MPICH' ) set mpich = 1
    if ( $opt == 'mpif90'|| $opt == 'MPIF90' ) set mpif90 = 1
    if ( $opt == 'lammpi'|| $opt == 'LAMMPI' ) set lammpi = 1
    if ( $opt == 'scali'|| $opt == 'SCALI' ) set scali = 1
    if ( $opt == 'mpispecial'|| $opt == 'MPISPECIAL' ) set mpispecial = 1
    if ( $opt == 'polyr' || $opt == 'POLYR' ) set polyrate = 1
# PJ 06/2005
    if ( $opt == 'pipf' || $opt == 'PIPF' ) set qpipf = 1

# MF 03/2006
# read extra flags in the form of +TAG or -TAG to modify pref.dat
    if ( { ( echo $opt | grep "^+" >& /dev/null ) } ) then
      set tag = `echo $opt | cut -c2- | sed 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
      set addprefdat = ( $addprefdat $tag )
    else if ( { ( echo $opt | grep "^-" >& /dev/null ) } ) then
      set tag = `echo $opt | cut -c2- | sed 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
      set delprefdat = ( $delprefdat $tag )
    endif
  end
endif

#
if ($?bigendian && $?littleendian ) then
    echo " install.com> Only big_e or lit_e can be specified. Not both."
    exit
endif
if ( $?bigendian ) setenv BIG_ENDIAN yes
if ( $?littleendian ) setenv LITTLE_ENDIAN yes

setenv REMOVE_F "/bin/rm -f"
setenv REMOVE_O "/bin/rm -f"
if ( $?keep_src ) setenv REMOVE_F "echo Keeping "
if ( $?keep_obj ) setenv REMOVE_O "echo Keeping "

setenv AR_COMMAND "ar rucv"
if($chm_host == 'ibmaix' || $chm_host == 'ibmaixmp' ) then
   setenv AR_COMMAND "ar -rucv"
   if ( $sgi64 == 1 ) then
       set ibm64 = 1
       set sgi64 = 0
       setenv AR_COMMAND "ar -rucv -X 64"
   endif
endif
#------------------------------------------------------------------------------
#=============================================================================
#                        SANITY CHECKS
#
if ($xreq == 1 && $nodsp == 1 ) then
    echo " install.com> Either X display or NODISP can be specified. Not both."
    exit
endif
#
if ( $scali ==  1 ) set mpiset=1
if ($mpiset == 1 && $pvmset == 1 ) then
    echo " install.com> Only PVM or MPI can be specified. Not both."
    exit
endif
#
if ($mpiset == 1 && $ensemble == 1 ) then
    echo " install.com> Ensemble replicas do not work with other parallel code"
    exit 
endif
if ($ensemble == 1 && ! ( $lammpi == 1 || $mpich == 1 ) ) then
    echo " install.com> You are building ensemble code ('E' flag) without"
    echo " install.com> specifying one of lam ('LAMMPI') or mpich ('MPICH')"
    exit
endif
#    -------------SGI 64 bit sanity check-----------
if ($sgi64 == 1 && $chm_host != sgi && $chm_host != sgi64) then
    echo " install.com> 64-bit compilation switch is only for SGI."
    exit
endif
#                     END of SANITY CHECKS
#---------------------------------------------------------------------------
#
#=============================================================================
#                        ENVIRONMENT SETUP
# set the host machine type environment variable chmhost
#
setenv chmhost $chm_host
#
# set chmroot to point the current directory (~/charmm) and
# set up the CHARMM installation environments.
#
setenv chmroot  `pwd`
setenv chmbuild $chmroot/build/$chm_host
setenv chmexec  $chmroot/exec/$chm_host
setenv chmlib   $chmroot/lib/$chm_host
setenv chmsrc   $chmroot/source
setenv chmtool  $chmroot/tool
setenv chmpar   serial
set path = ( $path $chmtool )
#
if (! -e $chmroot/exec ) mkdir $chmroot/exec
if (! -e $chmexec      ) mkdir $chmexec
if (! -e $chmroot/lib  ) mkdir $chmroot/lib
if (! -e $chmlib       ) mkdir $chmlib
#
if ($qmndo97 == 1) then
#  echo "Enter the absolute path to the modified MNDO makefile and machine specific makefiles"
#  echo "(Where are: Makefile_qmmm, irixx.mak, gnu.mak, aix4.mak, etc...?)"
#  echo -n ">> "
#  set mndopath = $<
   set mndopath = $chmroot/source/mndint/mndo97q
    if (! -e $mndopath) then
       echo "Error: can't find directory "$mndopath
       exit -1
    endif
endif
##
#
if ( $stopmark == 1 && -e $chmbuild ) then
  echo " "
  echo " install.com> Recreating directory $chmbuild."
  echo " "
  /bin/rm -r $chmbuild
endif
#    -----------OSX ENV VARS ----------------
# Makefile_osx to support gnu gfortran and g95 and xlf95 and ifort (Intel Macs) on Mac OSX
if ( $chm_host == osx ) then
    if ( $xlf95 == 1 ) then
      setenv XLF95_OSX YES
    else if ($ifort == 1 ) then
      setenv INTEL_IFORT YES
 #   else
 #     setenv GNU_G77 YES
    else if ($g95 == 1 ) then
      setenv GNU_G95 YES
    else #($gfortran == 1 ) then
      setenv GNU_GFORTRAN YES
    endif
    if( $mpiset == 1 ) setenv MPI_OSX YES
endif
#
#    -------------COMPILER SPECIFIC ENV VARS -----------------
# Makefile_GNU to support Absoft f77 / GNU g77 / f2c fort77 under Linux
if ( $chm_host == gnu ) then
  if ( $f77 == 1 ) then
    setenv ABSOFT_F77_V44 YES
  else if ( $f2c == 1 ) then
    setenv GNU_F2C YES
  else if ( $ifort == 1 ) then
    setenv INTEL_IFORT 1
    setenv INTEL32_IFC_IFORT yes
    if ( $longint == 1 ) then 
	setenv LONGINT 1
	setenv INTEL32_IFC_IFORT_I8 yes
	setenv INTEL32_IFC_IFORT
    endif
  else if ( $g95 == 1 ) then
    setenv GNU_G95 1
  else if ( $ifc == 1 ) then
    setenv INTEL32_IFC YES
    setenv INTEL32_IFC_IFORT yes
  else if ( $efc == 1 ) then
    set longint=1
    setenv INTEL64_EFC YES
  else if ( $g77 == 1 ) then
    setenv GNU_G77 YES
  else if ( $amd64 == 1 ) then
    setenv AMD64 YES
  else if ( $pathscale == 1 ) then
    setenv PATHSCALE YES
    if ( $x86_64 == 1 ) then
      set longint = 1
      setenv X86_64 YES
    endif
  else if ( $pgf95 == 1 ) then
    setenv PGI_F95 YES
    if ( $x86_64 == 1 ) then
      set longint = 1
      setenv X86_64 YES
    endif
  else if ( $cfort == 1 ) then
    set longint=1
    setenv COMPAQ_FORT YES
  else
    setenv GFORTRAN YES
    if ( $x86_64 == 1 ) then
      set longint = 1
      setenv X86_64 YES
    endif
  endif
else if ( $chm_host == g95 ) then
    setenv GNU_G95 1
endif

if ( $DEBUG == 1 ) then
  setenv DEBUG YES
endif  

#
#--------------------------------------------------------------#
#                                                              #   
#    Set up the build directory with makefiles and pref.dat    #
#                                                              #
#--------------------------------------------------------------#
if (! -e $chmbuild ) then
  echo " "
  echo " install.com> Directory $chmbuild does not exist."
  echo "              Creating $chmbuild ..."
  mkdir $chmbuild
  if (! -e $chmroot/build/UNX ) then
    echo " install.com> Directory $chmroot/build/UNX does not exist."
    echo "              CHARMM installation can not proceed."
    exit 1
  endif
  cp $chmroot/build/UNX/*.mk $chmbuild
  if ( $qcadpac == 1 ) then
    if ( $sgi64 == 1 ) then
      cp $chmroot/build/UNX/cadpac.mk_sgi64 $chmbuild/cadpac.mk
    else
      cp $chmroot/build/UNX/cadpac.mk_$chm_host $chmbuild/cadpac.mk
    endif
    if ( $mpiset == 1 ) then
     /bin/mv $chmbuild/cadpac.mk $chmbuild/cadpac.mk.$$
     sed -e 's/DEFS =/DEFS = -DMPI -DPARALLEL/' \
      $chmbuild/cadpac.mk.$$ > $chmbuild/cadpac.mk
     /bin/rm -f $chmbuild/cadpac.mk.$$
    endif
  endif

#
  if ( $qmndo97 == 1 ) then
    sed -e s@mndodir@$mndopath@ $chmroot/build/UNX/mndo97.mk_$chm_host > $chmbuild/mndo97.mk
  endif

  if ( $qsquantm == 1 ) then
      cp $chmroot/build/UNX/squantm.mk  $chmbuild/squantm.mk
  endif

  if ( $ibm64 == 1 ) then
    cp $chmroot/build/UNX/Makefile_${chm_host}64 $chmbuild/Makefile_$chm_host
  else
    cp $chmroot/build/UNX/Makefile_$chm_host $chmbuild
  endif
#
# Modify Makefile_template for graphics
flag:
  if( $xreq == 1 && $chm_host == hpux ) then
    sed -e '10s@grflib@-Wl,-L/usr/lib/X11R5 -lX11@' \
      $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
    sed -e '8s@cc @cc -Dxdisplay -I/usr/include/X11R5 @' \
      $chmbuild/Makefile_$$ > $chmbuild/Makefile_$chmhost
    /bin/rm $chmbuild/Makefile_$$
  else if( $xreq == 1 && $chm_host == alpha ) then
    sed -e '10s@grflib@-lX11 -ldnet_stub@' \
      $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
    sed -e '8s@cc @cc -Dxdisplay @' \
      $chmbuild/Makefile_$$ > $chmbuild/Makefile_$chmhost
    /bin/rm $chmbuild/Makefile_$$
  else if( $xreq == 1 && $chm_host == gnu ) then
    if ( $x86_64 == 1 ) then
      sed -e 's@grflib@-L/usr/X11R6/lib64 -lX11@' \
        $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
    else
      sed -e 's@grflib@-L/usr/X11R6/lib -lX11@' \
        $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
    endif
    sed -e 's@gcc @gcc -Dxdisplay @' -e 's@icc @icc -Dxdisplay @' \
      $chmbuild/Makefile_$$ > $chmbuild/Makefile_$chmhost
    /bin/rm $chmbuild/Makefile_$$
  else if( $xreq == 1 && $chm_host == g95 ) then
    sed -e 's@grflib@-L/usr/X11R6/lib -lX11@' \
      $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
    sed -e 's@gcc @gcc -Dxdisplay @' \
      $chmbuild/Makefile_$$ > $chmbuild/Makefile_$chmhost
    /bin/rm $chmbuild/Makefile_$$
  else if ( $xreq == 1 ) then
    sed -e '10s@grflib@-lX11@' \
      $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
    sed -e '8s@cc @cc -Dxdisplay @' \
        $chmbuild/Makefile_$$ > $chmbuild/Makefile_$chmhost
    /bin/rm $chmbuild/Makefile_$$
  else
    sed -e '10s@grflib@ @' \
      $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
    sed -e '8s@cc @cc @' \
        $chmbuild/Makefile_$$ > $chmbuild/Makefile_$chmhost
    /bin/rm  $chmbuild/Makefile_$$
  endif
#
# Modify Makefile_template to replace gcc with ccc on Alpha Linux
  if ( $chm_host == gnu && $cfort == 1 ) then
   sed -e 's/CC = gcc/CC = ccc/' \
       $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
   /bin/mv $chmbuild/Makefile_$$ $chmbuild/Makefile_$chmhost
  endif
# Modify Makefile_template to replace gcc with ecc on Linux w/ efc
  if ( $chm_host == gnu && $efc == 1 ) then
   sed -e 's/CC = gcc/CC = ecc/' \
       $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
   /bin/mv $chmbuild/Makefile_$$ $chmbuild/Makefile_$chmhost
  endif
# Modify Makefile_template to replace gcc with icc on Linux w/ ifort
  if ( $chm_host == gnu && $ifort == 1 ) then
   sed -e 's/CC = gcc/CC = icc/' \
       $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
   /bin/mv $chmbuild/Makefile_$$ $chmbuild/Makefile_$chmhost
  endif
# Modify Makefile_template for 64-bit compilation on SGI platforms
  if( $sgi64 == 1 ) then
    sed -e 's@f77@f77 -mips4 -64@' -e 's@-cckr@-mips4 -64 -cckr@' \
        $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
    /bin/mv $chmbuild/Makefile_$$ $chmbuild/Makefile_$chmhost
  endif
# Modify Makefile_template to replace gcc with cc -Dibmrs for MacOSX
  if ( $chm_host == osx ) then
    if( $xlf95 == 1) then
      sed -e 's/CC = gcc/CC = xlc/' \
          $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
	/bin/mv $chmbuild/Makefile_$$ $chmbuild/Makefile_$chmhost
	sed -e 's/-Dgnu/-Dibmrs -Dosx/' \
	    $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
	/bin/mv $chmbuild/Makefile_$$ $chmbuild/Makefile_$chmhost
    endif
    if( $ifort == 1 ) then
      sed -e 's/CC = gcc/CC = icc/' \
          $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
	/bin/mv $chmbuild/Makefile_$$ $chmbuild/Makefile_$chmhost
    endif
  endif
# Modify Makefile_template for GAMESS
  if ( $qgamess == 1 ) then
   awk '/gamint/ { print "	$(LIB)/gamess.a \\" } \
        /./       {print $0}' \
                    $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
   /bin/mv $chmbuild/Makefile_$$ $chmbuild/Makefile_$chmhost
  endif
# setup for APBS
  if ( $apbs == 1 && $chm_host == gnu ) then
      setenv APBS Y
      if ( ! $?APBS_LIB || ! $?IAPBS_LIB || ! $?APBS_BLAS ) then
        echo "APBS_LIB, IAPBS_LIB and APBS_BLAS variables must be set!"
	exit
      endif           
  endif
  if ( $apbs == 1 && $chm_host != gnu ) then
    echo "APBS build is supported on gnu platform only"
    exit
  endif

# Modify Makefile_template for long integer compilation
  if ( $longint == 1 ) then
      if ( $chm_host == sgi64 || \
           $chm_host == altix || \
           $chm_host == alpha || \
           ( $chm_host == gnu && $pathscale == 1 && $x86_64 == 1) || \
           ( $chm_host == gnu && $efc == 1) || \
           ( $chm_host == gnu && $ifort == 1) || \
           ( $chm_host == gnu && $x86_64 == 1) || \
           ( $chm_host == gnu && $cfort == 1) ) then
        sed -e 's/$(I8DUM1)/-i8/' \
          $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
        sed -e 's/$(I8DUM2)/-Di8/' \
          $chmbuild/Makefile_$$ > $chmbuild/Makefile_$chmhost
	  /bin/rm $chmbuild/Makefile_$$
      else
        echo "-i8 not available for this platform"
        echo "Update install.com and build/UNX/Makefile_$chmhost"
        exit -1
      endif
  endif

# Modify Makefile_template for pentium-4 or itanium class processors for intel compiler
  if ( $itanium == 1 && $ifort == 1) then
        sed -e 's/$(P4_OR_ITAN)/-tpp2/' \
          $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
        set mpi_compiler="mpif90 -Impi"
        set tpp_flag=-tpp2
        set compiler_flags=
   /bin/mv $chmbuild/Makefile_$$ $chmbuild/Makefile_$chmhost
  else
        sed -e 's/$(P4_OR_ITAN)/-tpp7/' \
          $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
   /bin/mv $chmbuild/Makefile_$$ $chmbuild/Makefile_$chmhost
  endif
      
# Modify Makefile_template for GAMESS-UK
  if ( $qgamessuk == 1 ) then
   if ( ${?CHMGUK_USE_GA} == 0) then
      setenv CHMGUK_USE_GA 0
   endif
   if ( $CHMGUK_USE_GA == 1 ) then
     # Check there is a GA build available, may need to force i8
     if ( $chmhost == sgi64 || \
          $chmhost == altix || \
          $chmhost == alpha || \
          ( $chmhost == gnu && $cfort == 1 ) ) then
       if ( $longint == 0 ) then
           echo "CHARMM/GAMESS-UK must be build with long integers (i8 keyword) if the GAs are required on" $chmhost
           exit -1
       endif
    endif

    awk '/gukint/ {print "	$(LIB)/gamessukga.a \\"; \
                  print "	$(LIB)/dft.a \\" } \
        /./       {print $0}' \
                    $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$

   else
     awk '/gukint/ {print "	$(LIB)/gamessuk.a \\"; \
                  print "	$(LIB)/dft.a \\" } \
        /./       {print $0}' \
                    $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$

   endif
   /bin/mv $chmbuild/Makefile_$$ $chmbuild/Makefile_$chmhost
#
# This section is needed to load additional libraries as needed 
# by GAMESS-UK
# For simplicity cluster network dependencies are left out here,
# so use mpispecial keyword to set comms flags and locations
#
      set BLAS  = ""

      if ( ${?CHMGUK_LIBS} == 1 ) then
          set BLAS=`echo $CHMGUK_LIBS`
      else if ( $chmhost == sgi ) then
         set BLAS=-lblas         
      else if ( $chmhost == sgi64 ) then
         # SGI Origin etc - use SCS library
         if ( $longint == 1 ) then
            set BLAS=-lscs_i8
         else
            set BLAS=-lscs
         endif
      else if ( $chmhost == altix ) then
         set BLAS=-lscs_i8
      else if ( $chmhost == alpha ) then
         # COMPAQ - use fortran blas in i8 case
         if ( $longint == 0 ) then
            set BLAS = -lcxml
        endif
      endif

      # Make the edits
      cat $chmbuild/Makefile_$chmhost | \
         sed -e "s@QLIB =@QLIB = $BLAS@" > $chmbuild/Makefile_$$
      mv $chmbuild/Makefile_$$ $chmbuild/Makefile_$chmhost

  endif
# Modify Makefile_template for CADPAC
  if ( $qcadpac == 1 ) then
   awk '/cadint/ { print "	$(LIB)/cadpac.a \\" } \
        /./       {print $0}' \
                    $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
   /bin/mv $chmbuild/Makefile_$$ $chmbuild/Makefile_$chmhost
  endif
# Modify Makefile_template for SCCDFTB
  if ( $qsccdftb == 1 ) then
   awk '/quantum.a/ { print "	$(LIB)/sccdftb.a \\\n \t$(LIB)/sccdftbint.a \\"} \
        /./       {print $0}' \
                    $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
   /bin/mv $chmbuild/Makefile_$$ $chmbuild/Makefile_$chmhost
  endif
#
  if ( $qgamess == 1 ) then
    switch ($chmhost)
      case t3e:
        cp $chmroot/build/UNX/gmscomp $chmtool/gmscomp_$chmhost
        sed -e 's@gamess-charmm-target@cray-t3e@g' \
         $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
        sed -e 's@activate-type@t3e@g' \
         $chmtool/gmscomp_$$ > $chmtool/gmscomp_$chmhost
        /bin/rm $chmtool/gmscomp_$$
        chmod +x $chmtool/gmscomp_$chmhost
        breaksw
      case ibmaixmp
        cp $chmroot/build/UNX/gmscomp $chmtool/gmscomp_$chmhost
        sed -e 's@gamess-charmm-target@ibm32@g' \
         $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
        sed -e 's@activate-type@ibmaixmp@g' \
         $chmtool/gmscomp_$$ > $chmtool/gmscomp_$chmhost
        /bin/rm $chmtool/gmscomp_$$
        chmod +x $chmtool/gmscomp_$chmhost
        breaksw
      case ibmaix
        cp $chmroot/build/UNX/gmscomp $chmtool/gmscomp_$chmhost
        sed -e 's@gamess-charmm-target@ibm32@g' \
         $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
        sed -e 's@activate-type@ibmaix@g' \
         $chmtool/gmscomp_$$ > $chmtool/gmscomp_$chmhost
        /bin/rm $chmtool/gmscomp_$$
        chmod +x $chmtool/gmscomp_$chmhost
        breaksw
      case sun:
#      case sun64:		# not tested - BC
        cp $chmroot/build/UNX/gmscomp $chmtool/gmscomp_$chmhost
        sed -e 's@gamess-charmm-target@sun@g' \
         $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
        sed -e 's@activate-type@sun@g' \
         $chmtool/gmscomp_$$ > $chmtool/gmscomp_$chmhost
        /bin/rm $chmtool/gmscomp_$$
        chmod +x $chmtool/gmscomp_$chmhost
        breaksw
      case sunmpi:
        cp $chmroot/build/UNX/gmscomp $chmtool/gmscomp_$chmhost
        sed -e 's@gamess-charmm-target@sun@g' \
         $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
        sed -e 's@activate-type@sun@g' \
         $chmtool/gmscomp_$$ > $chmtool/gmscomp_$chmhost
        /bin/rm $chmtool/gmscomp_$$
        chmod +x $chmtool/gmscomp_$chmhost
        breaksw
      case sgi:
      case sgi64:
        cp $chmroot/build/UNX/gmscomp $chmtool/gmscomp_$chmhost
        sed -e 's@gamess-charmm-target@sgi@g' \
         $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
        sed -e 's@activate-type@sgi@g' \
         $chmtool/gmscomp_$$ > $chmtool/gmscomp_$chmhost
        /bin/rm $chmtool/gmscomp_$$
        chmod +x $chmtool/gmscomp_$chmhost
        breaksw
      case altix:
        cp $chmroot/build/UNX/gmscomp $chmtool/gmscomp_$chmhost
        sed -e 's@gamess-charmm-target@sgi@g' \
         $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
        sed -e 's@activate-type@sgi@g' \
         $chmtool/gmscomp_$$ > $chmtool/gmscomp_$chmhost
        /bin/rm $chmtool/gmscomp_$$
        chmod +x $chmtool/gmscomp_$chmhost
        breaksw
      case hpux:
        cp $chmroot/build/UNX/gmscomp $chmtool/gmscomp_$chmhost
        sed -e 's@gamess-charmm-target@hp9000@g' \
         $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
        sed -e 's@activate-type@hpux@g' \
         $chmtool/gmscomp_$$ > $chmtool/gmscomp_$chmhost
        /bin/rm $chmtool/gmscomp_$$
        chmod +x $chmtool/gmscomp_$chmhost
        breaksw
      case alpha:
        cp $chmroot/build/UNX/gmscomp $chmtool/gmscomp_$chmhost
        sed -e 's@gamess-charmm-target@compaq-axp@g' \
         $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
        sed -e 's@activate-type@alpha@g' \
         $chmtool/gmscomp_$$ > $chmtool/gmscomp_$chmhost
        /bin/rm $chmtool/gmscomp_$$
        chmod +x $chmtool/gmscomp_$chmhost
        breaksw
      case gnu:
        cp $chmroot/build/UNX/gmscomp $chmtool/gmscomp_$chmhost
        if ( $cfort == 1 ) then
           mv $chmtool/gmscomp_$chmhost $chmtool/gmscomp_$$
           sed -e 's@gamess-charmm-target@compaq-axp@g' \
                  $chmtool/gmscomp_$$ > $chmtool/gmscomp_$chmhost 
           sed -e 's@f77@fort@g' \
                  $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
        else
           sed -e 's@gamess-charmm-target@linux-pc@g' \
                  $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
        endif
        sed -e 's@activate-type@gnu@g' \
                $chmtool/gmscomp_$$ > $chmtool/gmscomp_$chmhost

#    ----- F77 ---------------------------------         
        if ( $f77 == 1 ) then
#         these modifications could also be implemented in the same way
#         as for the main Makefile_gnu
            sed -e \
      's@GNU-Linux-compiler@f77 -f -N3 -N26 -B108 -O -U -B100 -B101  -N86@g' \
                  $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
#    ----- F2C ---------------------------------         
        else if ( $f2c == 1 ) then
            sed -e 's@GNU-Linux-compiler@fort77 -O2 -w -malign-double@g' \
                    $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
#    ----- IFC ---------------------------------         
        else if ( $ifc == 1 ) then
          if ( $mpiset == 1 && $scali == 0 ) then
            sed -e 's@GNU-Linux-compiler@mpif77 -O3 -tpp7 -axW@g' \
                    $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
          else
            sed -e 's@GNU-Linux-compiler@ifc -O3 -tpp7 -axW@g' \
                   $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
          endif
#    ----- IFORT ---------------------------------         
        else if ( $ifort == 1 ) then
          if ( $mpiset == 1 && $scali == 0 ) then
            sed -e 's@GNU-Linux-compiler@mpif90 -O3 -tpp7 -axW@g' \
                    $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
          else
            sed -e 's@GNU-Linux-compiler@ifort -O3 -tpp7 -axW@g' \
                   $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
          endif
#    ----- PGF77 ---------------------------------         
        else if ( $pgf95 == 1 ) then
          if ( $mpiset == 1 && $scali == 0 ) then
            sed -e \
    's@GNU-Linux-compiler@mpif90 -O2 -Munroll -tp p7 -Mnoframe@g' \
                   $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
          else
            sed -e \
                's@GNU-Linux-compiler@pgf95 -O2 -Munroll -tp p7 -Mnoframe@g' \
                    $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
          endif
        else if ( $cfort == 1 ) then
            sed -e \
          's@GNU-Linux-compiler@fort -i8 -O4 -math_library fast -tune host@g' \
                    $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
#   ----- G95 ---------------------------------         
        else if ( $g95 == 1) then
          if ( $mpiset == 1 ) then
              sed -e 's@GNU-Linux-compiler@mpif90 -O3 @g' \
                      $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
          else
              sed -e 's@GNU-Linux-compiler@g95 -O3@g' \
                      $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
          endif
          exit
#   ----- G77 ---------------------------------         
        else
          if ( $mpiset == 1 ) then
              sed -e 's@GNU-Linux-compiler@mpif77 -malign-double -march=i686 -O2 -fno-globals -Wno-globals@g' \
                      $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
          else
              sed -e 's@GNU-Linux-compiler@g77 -malign-double -march=i686 -O2 -fno-globals -Wno-globals@g' \
                      $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
          endif
        endif
        /bin/mv $chmtool/gmscomp_$$ $chmtool/gmscomp_$chmhost
        chmod +x $chmtool/gmscomp_$chmhost
        breaksw
      default:
        echo "This machine does not support GAMESS"
        exit
        breaksw
    endsw
    if ( $mpiset != 1 ) then
        sed -e 's@PARALLEL=true@PARALLEL=false@g' \
        $chmtool/gmscomp_$chmhost > $chmtool/gmscomp_$$
        /bin/mv $chmtool/gmscomp_$$ $chmtool/gmscomp_$chmhost
        chmod +x $chmtool/gmscomp_$chmhost
    endif
  endif
# --- end of if qgamess==1 ----------------------------

# Modify Makefile_template for Q-CHEM
  if ( $qqchem == 1 ) then
    /bin/mv $chmbuild/Makefile_$$ $chmbuild/Makefile_$chmhost
  endif

# Modify Makefile_template for MNDO97
  if ( $qmndo97 == 1 ) then
    if( $chm_host == gnu || $chm_host == altix ) then
      rm $mndopath/machine.mak
      if( $chm_host == gnu ) then
         ln -s $mndopath/gnu.mak $mndopath/machine.mak
      endif
      if( $chm_host == altix ) then
         ln -s $mndopath/altix.mak $mndopath/machine.mak
      endif
#
      awk '/mndint.a/ { print "	$(LIB)/mndo97.a \\" } \
           /./    {print $0}' \
                      $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
#     sed -e 's@ADDLIB := $(ADDLIB) $(GLIB)@ADDLIB := $(ADDLIB) $(GLIB) -I$(CVSHOME)/Software/Libraries/Y77LIB -L$(CVSHOME)/Software/Libraries/Y77LIB -lY77LIB -llapack -lblas `locate libg2c.a`@' \
#       $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
      /bin/mv $chmbuild/Makefile_$$ $chmbuild/Makefile_$chmhost
    endif
    if( $chm_host == sgi && $sgi64 == 0 ) then
      rm $mndopath/machine.mak
      ln -s $mndopath/irixx.mak $mndopath/machine.mak
      awk '/moldyn.a/ { print "	$(LIB)/mndint.a \\" } \
           /./       {print $0}' \
                      $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
      awk '/mndint/ { print "	$(LIB)/mndo97.a \\" } \
           /./       {print $0}' \
                      $chmbuild/Makefile_$$ > $chmbuild/Makefile_$chmhost
#     sed -e 's@ADDLIB := $(ADDLIB) $(GLIB)@ADDLIB := $(ADDLIB) $(GLIB) -I$(CVSHOME)/Software/Libraries/Y77LIB -L$(CVSHOME)/Software/Libraries/Y77LIB -lY77LIB -llapack -lblas `locate libg2c.a`@' \
#       $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
      sed -e 's@stamp @stamp mndo @' \
        $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
      sed -e 's@= -lblas@=  @' \
        $chmbuild/Makefile_$$ > $chmbuild/Makefile_$chmhost
      sed -e 's@(GLIB) @(GLIB) $(LIBMNDO) @' \
        $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
      /bin/mv $chmbuild/Makefile_$$ $chmbuild/Makefile_$chmhost
#     /bin/rm $chmbuild/Makefile_$$
    endif
    if( $chm_host == sgi && $sgi64 == 1 ) then
#
# need to put appropriate stuff here for Makefile_sgi64
#
    endif
    if ($chm_host == ibmaix ) then
     rm $mndopath/machine.mak
     ln -s $mndopath/aix4.mak $mndopath/machine.mak
#
     awk '/BLAS = -lblas/ { print "LIBMNDO = $(LIB)/libps96.a $(LIB)/libla96.a $(LIB)/libbl96.a \n" } \
          /./       {print $0}' \
                      $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
     awk '/moldyn.a/ { print "	$(LIB)/mndint.a \\" } \
          /./       {print $0}' \
                      $chmbuild/Makefile_$$ > $chmbuild/Makefile_$chmhost
     awk '/mndint/ { print "	$(LIB)/mndo97.a \\" } \
          /./       {print $0}' \
                      $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$ 
#     sed -e 's@ADDLIB := $(ADDLIB) $(GLIB)@ADDLIB := $(ADDLIB) $(GLIB) -I$(CVSHOME)/Software/Libraries/Y77LIB -L$(CVSHOME)/Software/Libraries/Y77LIB -lY77LIB -llapack -lblas `locate libg2c.a`@' \
#       $chmbuild/Makefile_$$ > $chmbuild/Makefile_$chmhost
      sed -e 's@stamp @stamp mndo @' \
        $chmbuild/Makefile_$$ > $chmbuild/Makefile_$chmhost
      sed -e 's@= -lblas@=  @' \
        $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
      sed -e 's@(GLIB) @(GLIB) $(LIBMNDO) @' \
        $chmbuild/Makefile_$$ > $chmbuild/Makefile_$chmhost
#    /bin/mv $chmbuild/Makefile_$$ $chmbuild/Makefile_$chmhost
     /bin/rm $chmbuild/Makefile_$$
    endif
  endif

# Modify Makefile_template for SQUANTM
  if ( $qsquantm == 1 ) then
     switch ($chmhost)
       case ibmaixmp:
         awk '/util.a/ { print "	$(LIB)/squantm.a \\" } \
              /./      {print $0}' \
                     $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
         /bin/mv -f  $chmbuild/Makefile_$$   $chmbuild/Makefile_$chmhost
         breaksw
       case ibmaix:
         awk '/util.a/ { print "	$(LIB)/squantm.a \\" } \
              /./      {print $0}' \
                     $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
         /bin/mv -f  $chmbuild/Makefile_$$   $chmbuild/Makefile_$chmhost
         breaksw
       case altix:
         awk '/util.a/ { print "	$(LIB)/squantm.a \\" } \
              /./      {print $0}' \
                     $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
         /bin/mv -f  $chmbuild/Makefile_$$  $chmbuild/Makefile_$chmhost
         breaksw
       case gnu:
         if ( $ifort == 1 || $f2c == 1 || $ifc == 1 || $gfortran == 1 ) then
                           $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
            awk '/util.a/ { print "	$(LIB)/squantm.a \\" } \
                 /./      {print $0}' \
                        $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
            /bin/mv -f  $chmbuild/Makefile_$$  $chmbuild/Makefile_$chmhost
         else
              echo "This compiler does not suport SQUANTM"
              exit
         endif
         breaksw
       default:
         echo "This machine does not support  SQUANTM"
         exit
         breaksw
     endsw
  endif

# PJ 06/2005
# Modify Makefile_template for PIPF
  if ( $qpipf == 1 ) then
   awk '/quantum/ { print "	$(LIB)/pipf.a \\" } \
        /./       {print $0}' \
                    $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
   /bin/mv $chmbuild/Makefile_$$ $chmbuild/Makefile_$chmhost
  endif

endif

if ( $stopmark == 1 ) then
  echo " "
  echo " install.com> Installation STOPs after creating "
  echo "              the $chmbuild directory."
  echo " "
  exit 1
endif
#
if (! -e $chmtool  ) then
  echo " "
  echo " install.com> Directory $chmtool does not exist."
  echo "              CHARMM installation can not proceed."
  exit 1
endif
echo " "
echo " install.com> Phase 1 completed."
#
#-----------------------------------------------------------------------
#
phase2:
# (2.1) generate the PREFX preprocessor 
# (2.2) generate the PREFX data file PREF.DAT
#
#
pushd $chmtool >> /dev/null
#
switch ($chm_host)
  case alpha:
    if (! -e prefx_alpha  )   f77 -o prefx_$$    prefx.f
    echo "ALPHA"    >! $chmbuild/pref$$.dat
    echo "UNIX"     >> $chmbuild/pref$$.dat
    echo "SCALAR"   >> $chmbuild/pref$$.dat
    if ( $pvmset == 1 ) echo "PVMC"       >> $chmbuild/pref$$.dat
    if ( $socket == 1 ) echo "SOCKET"     >> $chmbuild/pref$$.dat
    if($pvmset == 1 || $socket == 1 ) then
       echo "CMPI"       >> $chmbuild/pref$$.dat
       echo "PARALLEL"   >> $chmbuild/pref$$.dat
       echo "GENCOMM"    >> $chmbuild/pref$$.dat
       echo "PARAFULL"   >> $chmbuild/pref$$.dat
       echo "SYNCHRON"   >> $chmbuild/pref$$.dat
    endif
    if($mpiset == 1 ) then
       echo "CMPI"       >> $chmbuild/pref$$.dat
       echo "MPI"        >> $chmbuild/pref$$.dat
       echo "PARALLEL"   >> $chmbuild/pref$$.dat
       echo "GENCOMM"    >> $chmbuild/pref$$.dat
       echo "PARAFULL"   >> $chmbuild/pref$$.dat
    endif
    breaksw
  case alphamp:
    if (! -e prefx_alphamp  )   f77 -o prefx_$$    prefx.f
    echo "ALPHA"    >! $chmbuild/pref$$.dat
    echo "ALPHAMP"  >> $chmbuild/pref$$.dat
    echo "UNIX"     >> $chmbuild/pref$$.dat
    echo "SCALAR"   >> $chmbuild/pref$$.dat
    echo "PARALLEL"   >> $chmbuild/pref$$.dat
    echo "PARAFULL"   >> $chmbuild/pref$$.dat
    echo "CMPI"       >> $chmbuild/pref$$.dat
    echo "GENCOMM"    >> $chmbuild/pref$$.dat
    if($pvmset == 1 ) then
       echo "PVMC"      >> $chmbuild/pref$$.dat
       echo "SYNCHRON"   >> $chmbuild/pref$$.dat
    endif
    if($mpiset == 1 ) then
       echo "MPI"        >> $chmbuild/pref$$.dat
    endif
    breaksw
  case altix:
    if (! -e prefx_altix ) ifort -static -o prefx_$$  prefx.f
    echo "ALTIX"     >! $chmbuild/pref$$.dat  
    echo "UNIX"     >> $chmbuild/pref$$.dat
    echo "SCALAR"   >> $chmbuild/pref$$.dat
    echo "FASTENBFS8"   >> $chmbuild/pref$$.dat
    echo "I4BINARY"   >> $chmbuild/pref$$.dat
    if ( $mpiset == 1 ) then
        echo "CMPI"        >> $chmbuild/pref$$.dat
        echo "MPI"         >> $chmbuild/pref$$.dat
        echo "ALTIX_MPI"   >> $chmbuild/pref$$.dat
        echo "PARALLEL"    >> $chmbuild/pref$$.dat
        echo "PARAFULL"    >> $chmbuild/pref$$.dat
    endif
    breaksw
  case gnu:
    set forcom = gfortran
    if ( $g95 == 1 ) set forcom = g95
    if ( $f77 == 1 ) set forcom = f77
    if ( $f2c == 1 ) set forcom = fort77
    if ( $g77 == 1 ) set forcom = g77
    if ( $ifc == 1 ) set forcom = ifc
    if ( $efc == 1 ) set forcom = efc
    if ( $ifort == 1 ) set forcom = ifort
    if ( $pgf95 == 1 ) set forcom = pgf95
    if ( $cfort == 1 ) set forcom = fort
    if ( $gfortran == 1 ) set forcom = "gfortran -static"
    if ( $pathscale == 1 ) set forcom = pathf90
    if (! -e prefx_gnu  )   $forcom -o prefx_$$    prefx.f
    echo "GNU"      >! $chmbuild/pref$$.dat
    if($g95 == 1) echo "G95" >> $chmbuild/pref$$.dat
    echo "UNIX"     >> $chmbuild/pref$$.dat
    echo "SCALAR"   >> $chmbuild/pref$$.dat
    if ( $pvmset == 1 ) echo "PVMC"       >> $chmbuild/pref$$.dat
    if ( $socket == 1 ) echo "SOCKET"     >> $chmbuild/pref$$.dat
    if ( $pvmset == 1 || $socket == 1 ) then
        echo "CMPI"       >> $chmbuild/pref$$.dat
        echo "PARALLEL"   >> $chmbuild/pref$$.dat
        echo "PARAFULL"   >> $chmbuild/pref$$.dat
        echo "SYNCHRON"   >> $chmbuild/pref$$.dat
    endif
    if ( $x86_64 == 1 ) then
	echo "I4BINARY"   >> $chmbuild/pref$$.dat
       if($pathscale == 1) echo "PATHSCALE"  >> $chmbuild/pref$$.dat
    endif
    if($gfortran == 1 ) then
	echo "GFORTRAN"   >> $chmbuild/pref$$.dat
    endif
    if($mpiset == 1 ) then
       echo "CMPI"       >> $chmbuild/pref$$.dat
       echo "MPI"        >> $chmbuild/pref$$.dat
       echo "PARALLEL"   >> $chmbuild/pref$$.dat
       echo "PARAFULL"   >> $chmbuild/pref$$.dat
       if($pathscale == 1 && $x86_64 == 1 ) then
	echo "ALTIX_MPI"  >> $chmbuild/pref$$.dat
       endif
    endif
    breaksw
  case g95:
    set forcom = g95
    if (! -e prefx_g95  )   $forcom -o prefx_$$    prefx.f
    echo "GNU"      >! $chmbuild/pref$$.dat
    echo "G95"      >> $chmbuild/pref$$.dat
    echo "UNIX"     >> $chmbuild/pref$$.dat
    echo "SCALAR"   >> $chmbuild/pref$$.dat
    if ( $pvmset == 1 || $socket == 1 ) then
        echo "PVM and SOCKET not supported for g95"
        exit -1
    endif
    if ( $x86_64 == 1 ) then
	echo "I4BINARY"   >> $chmbuild/pref$$.dat
    endif
    if($mpiset == 1 ) then
       echo "CMPI"       >> $chmbuild/pref$$.dat
       echo "MPI"        >> $chmbuild/pref$$.dat
       echo "PARALLEL"   >> $chmbuild/pref$$.dat
       echo "PARAFULL"   >> $chmbuild/pref$$.dat
    endif
    breaksw
  case hal:
    if (! -e prefx_hal)    f90 -KV8 -o prefx_$$    prefx.f
    echo "HAL"      >! $chmbuild/pref$$.dat
    echo "UNIX"     >> $chmbuild/pref$$.dat
    echo "SCALAR"   >> $chmbuild/pref$$.dat
    breaksw
#------------------ Pentium-4 EM64T --------------------------------
  case em64t:
    if (! -e prefx_em64t )  ifort -o prefx_$$  prefx.f
    echo "GNU"      >!  $chmbuild/pref$$.dat
    echo "EM64T"    >>  $chmbuild/pref$$.dat
    echo "UNIX"     >>  $chmbuild/pref$$.dat
    echo "SCALAR"   >>  $chmbuild/pref$$.dat
    echo "INTEGER8" >>  $chmbuild/pref$$.dat
    echo "I4BINARY"    >> $chmbuild/pref$$.dat
    if ( $pvmset == 1 ) then
	echo "PVM not supported for itanium"
        exit 2
    endif
    if ( $mpiset == 1 ) then
        echo "MPI"         >> $chmbuild/pref$$.dat
        echo "PARALLEL"    >> $chmbuild/pref$$.dat
        echo "PARAFULL"    >> $chmbuild/pref$$.dat
        echo "FILEINPUT"    >> $chmbuild/pref$$.dat
        echo "IA64_MPI"    >> $chmbuild/pref$$.dat
	setenv MPI_EM64T YES
    endif
    breaksw
#------------------ ITANIUM --------------------------------
  case itanium:
    if (! -e prefx_itanium )  ifort -o prefx_$$  prefx.f
    echo "GNU"     >! $chmbuild/pref$$.dat
    echo "ITANIUM"     >! $chmbuild/pref$$.dat
    echo "UNIX"     >> $chmbuild/pref$$.dat
    echo "SCALAR"   >> $chmbuild/pref$$.dat
    echo "INTEGER8" >>  $chmbuild/pref$$.dat
    if ( $pvmset == 1 ) then
	echo "PVM not supported for itanium"
        exit 2
    endif
    if ( $mpiset == 1 ) then
        echo "MPI"         >> $chmbuild/pref$$.dat
        echo "PARALLEL"    >> $chmbuild/pref$$.dat
        echo "PARAFULL"    >> $chmbuild/pref$$.dat
        echo "FILEINPUT"    >> $chmbuild/pref$$.dat
        echo "I4BINARY"    >> $chmbuild/pref$$.dat
        echo "IA64_MPI"    >> $chmbuild/pref$$.dat
        echo "MPIF90"     >> $chmbuild/pref$$.dat
    endif
    breaksw
#------------------ HP ITANIUM --------------------------------
  case hpitanium:
    if (! -e prefx_hpitanium )  f90 -o prefx_$$  prefx.f
    echo "HPITANIUM"     >! $chmbuild/pref$$.dat
    echo "UNIX"     >> $chmbuild/pref$$.dat
    echo "SCALAR"   >> $chmbuild/pref$$.dat
    if ( $pvmset == 1 ) then
        echo "PVMC"        >> $chmbuild/pref$$.dat
        echo "CMPI"        >> $chmbuild/pref$$.dat
        echo "PARALLEL"    >> $chmbuild/pref$$.dat
        echo "PARAFULL"    >> $chmbuild/pref$$.dat
        echo "SYNCHRON"    >> $chmbuild/pref$$.dat
        echo "GENCOMM"     >> $chmbuild/pref$$.dat
        echo "I4BINARY"    >> $chmbuild/pref$$.dat
    endif
    if ( $mpiset == 1 ) then
        echo "CMPI"        >> $chmbuild/pref$$.dat
        echo "MPI"         >> $chmbuild/pref$$.dat
        echo "PARALLEL"    >> $chmbuild/pref$$.dat
        echo "PARAFULL"    >> $chmbuild/pref$$.dat
        echo "I4BINARY"    >> $chmbuild/pref$$.dat
    endif
    breaksw
  case hpux:
    if (! -e prefx_hpux)    f77 -o prefx_$$    prefx.f
    echo "HPUX"     >! $chmbuild/pref$$.dat
    echo "UNIX"     >> $chmbuild/pref$$.dat
    echo "SCALAR"   >> $chmbuild/pref$$.dat
    if ( $pvmset == 1 ) echo "PVMC"       >> $chmbuild/pref$$.dat
    if ( $socket == 1 ) echo "SOCKET"     >> $chmbuild/pref$$.dat
    if ( $pvmset == 1 || $socket == 1 ) then
        echo "CMPI"       >> $chmbuild/pref$$.dat
        echo "PARALLEL"   >> $chmbuild/pref$$.dat
        echo "GENCOMM"    >> $chmbuild/pref$$.dat
        echo "PARAFULL"   >> $chmbuild/pref$$.dat
        echo "SYNCHRON"   >> $chmbuild/pref$$.dat
    endif
    breaksw
  case ibmaix:
    if (! -e prefx_ibmaix)    xlf -o prefx_$$    prefx.f
    echo "IBMAIX"    >! $chmbuild/pref$$.dat
    echo "UNIX"     >> $chmbuild/pref$$.dat
    echo "SCALAR"   >> $chmbuild/pref$$.dat
    if ( $ibm64 == 1 ) echo "INTEGER8"   >> $chmbuild/pref$$.dat
    if ( $ibm64 == 1 ) echo "I4BINARY"   >> $chmbuild/pref$$.dat
    breaksw
  case ibmaixmp:
    if (! -e prefx_ibmaixmp)    xlf -o prefx_$$    prefx.f
    echo "IBMAIX"    >! $chmbuild/pref$$.dat
    echo "UNIX"     >> $chmbuild/pref$$.dat
    echo "SCALAR"   >> $chmbuild/pref$$.dat
    echo "PARALLEL"   >> $chmbuild/pref$$.dat
    echo "PARAFULL"   >> $chmbuild/pref$$.dat
    echo "MPI"        >> $chmbuild/pref$$.dat
    echo "FILEINPUT"  >> $chmbuild/pref$$.dat
    if ( $ibm64 == 1 ) echo "INTEGER8"   >> $chmbuild/pref$$.dat
    if ( $ibm64 == 1 ) echo "I4BINARY"   >> $chmbuild/pref$$.dat
    if ( $ibm64 == 1 ) echo "IBMAIX_MPI64"   >> $chmbuild/pref$$.dat
    breaksw
  case ibmlnxmp:
    if (! -e prefx_ibmlnxmp)    xlf -o prefx_$$    prefx.f
    echo "IBMAIX"    >! $chmbuild/pref$$.dat
    echo "UNIX"     >> $chmbuild/pref$$.dat
    echo "SCALAR"   >> $chmbuild/pref$$.dat
    echo "PARALLEL"   >> $chmbuild/pref$$.dat
    echo "PARAFULL"   >> $chmbuild/pref$$.dat
    echo "MPI"        >> $chmbuild/pref$$.dat
    if ( $ibm64 == 1 ) echo "INTEGER8"   >> $chmbuild/pref$$.dat
    if ( $ibm64 == 1 ) echo "I4BINARY"   >> $chmbuild/pref$$.dat
    if ( $ibm64 == 1 ) echo "IBMAIX_MPI64"   >> $chmbuild/pref$$.dat
    breaksw
  case osx:
    set forcom = gfortran
    if ( $xlf95 == 1 ) then	
	echo "OSX"      >! $chmbuild/pref$$.dat
	set forcom = xlf95
    else if ( $ifort == 1 || $g95 == 1 ) then
	echo "GNU"      >! $chmbuild/pref$$.dat
	if ( $ifort == 1 ) then
	    set forcom = ifort
	else if ( $g95 == 1 ) then
	    set forcom = g95
	    echo "G95"   >>! $chmbuild/pref$$.dat
	endif
    else
	echo "GNU"      >! $chmbuild/pref$$.dat
	echo "GFORTRAN"   >>! $chmbuild/pref$$.dat
    endif
    if (! -e prefx_osx  ) then
	if ( $xlf95 == 1 ) then 
	    $forcom -qfixed -o prefx_$$    prefx.f
	else
	    $forcom -o prefx_$$    prefx.f
	endif
    endif
    echo "UNIX"     >> $chmbuild/pref$$.dat
    echo "SCALAR"   >> $chmbuild/pref$$.dat
    if ( $pvmset == 1 ) echo "PVMC"       >> $chmbuild/pref$$.dat
    if ( $socket == 1 ) echo "SOCKET"     >> $chmbuild/pref$$.dat
    if ( $pvmset == 1 || $socket == 1 ) then
        echo "CMPI"       >> $chmbuild/pref$$.dat
        echo "PARALLEL"   >> $chmbuild/pref$$.dat
        echo "GENCOMM"    >> $chmbuild/pref$$.dat
        echo "PARAFULL"   >> $chmbuild/pref$$.dat
        echo "SYNCHRON"   >> $chmbuild/pref$$.dat
    endif
    if($mpiset == 1 ) then
       echo "MPI"        >> $chmbuild/pref$$.dat
       echo "PARALLEL"   >> $chmbuild/pref$$.dat
       echo "PARAFULL"   >> $chmbuild/pref$$.dat
    endif
    breaksw
  case sgi:
  case sgi64:
    if (! -e prefx_sgi || ! -e prefx_sgi64)  f77 -static -o prefx_$$  prefx.f
    echo "IRIS"     >! $chmbuild/pref$$.dat
#    echo "SGIF90"   >! $chmbuild/pref$$.dat
    echo "UNIX"     >> $chmbuild/pref$$.dat
    echo "SCALAR"   >> $chmbuild/pref$$.dat
    echo "FASTENBFS8"   >> $chmbuild/pref$$.dat
    if ( $pvmset == 1 ) then
        echo "PVMC"        >> $chmbuild/pref$$.dat
        echo "CMPI"        >> $chmbuild/pref$$.dat
        echo "PARALLEL"    >> $chmbuild/pref$$.dat
        echo "PARAFULL"    >> $chmbuild/pref$$.dat
        echo "SGIMP"       >> $chmbuild/pref$$.dat
        echo "SYNCHRON"    >> $chmbuild/pref$$.dat
        echo "GENCOMM"     >> $chmbuild/pref$$.dat
    endif
    if ( $mpiset == 1 ) then
        echo "CMPI"        >> $chmbuild/pref$$.dat
        echo "MPI"         >> $chmbuild/pref$$.dat
        echo "PARALLEL"    >> $chmbuild/pref$$.dat
        echo "PARAFULL"    >> $chmbuild/pref$$.dat
        echo "NIH"         >> $chmbuild/pref$$.dat
    endif
    breaksw
  case sun:
    if (! -e prefx_sun)    f77 -o prefx_$$    prefx.f
    echo "SUN"      >! $chmbuild/pref$$.dat
    echo "UNIX"     >> $chmbuild/pref$$.dat
    echo "SCALAR"   >> $chmbuild/pref$$.dat
    breaksw
  case sunmpi:
    if (! -e prefx_sunmpi)    f77 -o prefx_sunmpi    prefx.f
    echo "SUN"      >! $chmbuild/pref$$.dat
    echo "UNIX"     >> $chmbuild/pref$$.dat
    echo "SCALAR"   >> $chmbuild/pref$$.dat
    echo "CMPI"      >> $chmbuild/pref$$.dat
    echo "MPI"      >> $chmbuild/pref$$.dat
    echo "PARALLEL" >> $chmbuild/pref$$.dat
    echo "PARAFULL" >> $chmbuild/pref$$.dat
    echo "GENCOMM"   >> $chmbuild/pref$$.dat
    breaksw
  case sun64:
    if (! -e prefx_sun64)    f77 -o prefx_$$    prefx.f
    echo "SUN"      >! $chmbuild/pref$$.dat
    echo "SUN64"    >> $chmbuild/pref$$.dat
    echo "UNIX"     >> $chmbuild/pref$$.dat
    echo "SCALAR"   >> $chmbuild/pref$$.dat
    breaksw
  case t3e:
    if (! -e prefx_t3e)    f90 -o prefx_$$    prefx.f
    echo "T3E"      >! $chmbuild/pref$$.dat
    echo "UNIX"     >> $chmbuild/pref$$.dat
    echo "SCALAR"   >> $chmbuild/pref$$.dat
    echo "PARALLEL"   >> $chmbuild/pref$$.dat
    echo "PARAFULL"   >> $chmbuild/pref$$.dat
    echo "I4BINARY"    >> $chmbuild/pref$$.dat
    breaksw
  default:
    echo " install.com> Unsupported host-machine-type specified."
    exit
    breaksw
endsw
#
if ( -e prefx_$$ ) then
  mv prefx_$$ prefx_$chm_host
  echo " "
  echo " install.com> The preprocessor prefx_$chm_host installed."
endif
#
popd >> /dev/null
#

if ( $longint == 1 ) then
   echo "INTEGER8"    >> $chmbuild/pref$$.dat
endif

switch ($chm_size)
  case huge:
    echo "HUGE"     >> $chmbuild/pref$$.dat
    breaksw
  case xxlarge:
    echo "XXLARGE"  >> $chmbuild/pref$$.dat
    breaksw
  case xlarge:
    echo "XLARGE"   >> $chmbuild/pref$$.dat
    breaksw
  case large:
    echo "LARGE"    >> $chmbuild/pref$$.dat
    breaksw
  case medium:
    echo "MEDIUM"   >> $chmbuild/pref$$.dat
    breaksw
  case small:
    echo "SMALL"    >> $chmbuild/pref$$.dat
    breaksw
  case xsmall:
    echo "XSMALL"   >> $chmbuild/pref$$.dat
    breaksw
  case reduce:
    echo "REDUCE"  >> $chmbuild/pref$$.dat
    breaksw
  default:
    echo " "
    echo " install.com> Unrecognized CHARMM size specified."
    echo "              As default, MEDIUM will be used."
    echo "MEDIUM"   >> $chmbuild/pref$$.dat
    breaksw
endsw
#
# generic preprocessing keys to build CHARMM
  echo "EXPAND"     >> $chmbuild/pref$$.dat
  echo "PUTFCM"     >> $chmbuild/pref$$.dat
  echo "FCMDIR=fcm" >> $chmbuild/pref$$.dat
#
# specify parallel platform preprocessor keys
# and supported features to non-parallel platforms
if ( $chm_host == alphamp ) then
  echo "NOCORREL"   >> $chmbuild/pref$$.dat
  echo "NOVIBRAN"   >> $chmbuild/pref$$.dat
  echo "NOST2"      >> $chmbuild/pref$$.dat
else if ( $chm_host == t3e ) then
  echo "NOCORREL"   >> $chmbuild/pref$$.dat
  echo "NOVIBRAN"   >> $chmbuild/pref$$.dat
  echo "NOST2"      >> $chmbuild/pref$$.dat
  echo "NO_BYCC"    >> $chmbuild/pref$$.dat
  echo "NO_BYCU"    >> $chmbuild/pref$$.dat
else
  if ( $full == 1 ) then
    echo "ACE"        >> $chmbuild/pref$$.dat
    echo "ADUMB"      >> $chmbuild/pref$$.dat
    echo "AFM"        >> $chmbuild/pref$$.dat
    if ( $apbs == 1 ) then
      echo "APBS"     >> $chmbuild/pref$$.dat
    endif
    echo "ASPENER"    >> $chmbuild/pref$$.dat
    echo "ASPMEMB"    >> $chmbuild/pref$$.dat
    echo "BANBA"      >> $chmbuild/pref$$.dat
    echo "BLOCK"      >> $chmbuild/pref$$.dat
    echo "CFF"        >> $chmbuild/pref$$.dat
    echo "CGENFF"     >> $chmbuild/pref$$.dat
    echo "CHEQ"       >> $chmbuild/pref$$.dat
    echo "CMAP"       >> $chmbuild/pref$$.dat
    echo "DIMB"       >> $chmbuild/pref$$.dat
    echo "DMCONS"     >> $chmbuild/pref$$.dat
    echo "DOCK"       >> $chmbuild/pref$$.dat
    echo "DYNVV2"     >> $chmbuild/pref$$.dat
    echo "EMAP"       >> $chmbuild/pref$$.dat
    echo "ESTATS"     >> $chmbuild/pref$$.dat
    echo "FASTEW"     >> $chmbuild/pref$$.dat
    echo "FLEXPARM"   >> $chmbuild/pref$$.dat
    echo "FLUCQ"      >> $chmbuild/pref$$.dat
    echo "FMA"        >> $chmbuild/pref$$.dat
    echo "FOURD"      >> $chmbuild/pref$$.dat
    echo "FSSHK"      >> $chmbuild/pref$$.dat
    echo "GBBLCK"     >> $chmbuild/pref$$.dat
    echo "GBFIXAT"    >> $chmbuild/pref$$.dat
    echo "GBIM"       >> $chmbuild/pref$$.dat
    echo "GBINLINE"   >> $chmbuild/pref$$.dat
    echo "GBMV"       >> $chmbuild/pref$$.dat
    echo "GBMVFAST"   >> $chmbuild/pref$$.dat
    echo "HDGB"       >> $chmbuild/pref$$.dat
    echo "HQBM"       >> $chmbuild/pref$$.dat
    echo "GBSW"       >> $chmbuild/pref$$.dat
    echo "GBSWIT"     >> $chmbuild/pref$$.dat
    echo "GCMC"       >> $chmbuild/pref$$.dat
    echo "GENETIC"    >> $chmbuild/pref$$.dat
    echo "GENBORN"    >> $chmbuild/pref$$.dat
    echo "GOMODEL"    >> $chmbuild/pref$$.dat
    echo "GRID"       >> $chmbuild/pref$$.dat
    echo "GSBP"       >> $chmbuild/pref$$.dat
    echo "HMCM"       >> $chmbuild/pref$$.dat
    echo "IMCUBES"    >> $chmbuild/pref$$.dat
    echo "LATTICE"    >> $chmbuild/pref$$.dat
    echo "LDM"        >> $chmbuild/pref$$.dat
    echo "LDLAN"      >> $chmbuild/pref$$.dat
    echo "LDMGEN"     >> $chmbuild/pref$$.dat
    echo "LONEPAIR"   >> $chmbuild/pref$$.dat
    echo "LMC"        >> $chmbuild/pref$$.dat
    echo "LRST"       >> $chmbuild/pref$$.dat
    echo "LRVDW"      >> $chmbuild/pref$$.dat
    echo "MC"         >> $chmbuild/pref$$.dat
    echo "MEHMC"      >> $chmbuild/pref$$.dat
    echo "MMFF"       >> $chmbuild/pref$$.dat
    echo "MOLVIB"     >> $chmbuild/pref$$.dat
#    echo "MTS"        >> $chmbuild/pref$$.dat
    echo "MULTCAN"    >> $chmbuild/pref$$.dat
    echo "NBIPS"      >> $chmbuild/pref$$.dat
    echo "NEWTIMER"   >> $chmbuild/pref$$.dat
    echo "OLDDYN"     >> $chmbuild/pref$$.dat
    echo "OPLS"       >> $chmbuild/pref$$.dat
    echo "OVERLAP"    >> $chmbuild/pref$$.dat
    echo "PATHINT"    >> $chmbuild/pref$$.dat
    echo "PBEQ"       >> $chmbuild/pref$$.dat
    echo "PBOUND"     >> $chmbuild/pref$$.dat
    echo "PERT"       >> $chmbuild/pref$$.dat
    echo "PHMD"       >> $chmbuild/pref$$.dat
# PJ 06/2005
    if ($qpipf == 1) then
       echo "PIPF"       >> $chmbuild/pref$$.dat
    endif
    echo "POLAR"      >> $chmbuild/pref$$.dat
    echo "PSSP"       >> $chmbuild/pref$$.dat
    echo "PM1"        >> $chmbuild/pref$$.dat
    echo "PMEPLSMA"   >> $chmbuild/pref$$.dat
    echo "PNOE"       >> $chmbuild/pref$$.dat
    echo "PRIMSH"     >> $chmbuild/pref$$.dat
    echo "RCFFT"      >> $chmbuild/pref$$.dat
    echo "RDFSOL"     >> $chmbuild/pref$$.dat
    echo "REPLICA"    >> $chmbuild/pref$$.dat
    echo "RGYCONS"    >> $chmbuild/pref$$.dat
#    echo "RISM"       >> $chmbuild/pref$$.dat
    echo "RPATH"      >> $chmbuild/pref$$.dat
    echo "RXNCOR"     >> $chmbuild/pref$$.dat
    echo "SASAE"      >> $chmbuild/pref$$.dat
    echo "SCPISM"     >> $chmbuild/pref$$.dat
    echo "SGLD"       >> $chmbuild/pref$$.dat
    echo "SHAPES"     >> $chmbuild/pref$$.dat
    echo "SHELL"      >> $chmbuild/pref$$.dat
    echo "SOFTVDW"    >> $chmbuild/pref$$.dat
#    echo "SPAS"       >> $chmbuild/pref$$.dat
#    echo "SSNMR"      >> $chmbuild/pref$$.dat
#    echo "TESTENDIAN" >> $chmbuild/pref$$.dat
    echo "TNPACK"     >> $chmbuild/pref$$.dat
    echo "TPS"        >> $chmbuild/pref$$.dat
    echo "TRAVEL"     >> $chmbuild/pref$$.dat
    echo "TSM"        >> $chmbuild/pref$$.dat
    echo "TSALLIS"    >> $chmbuild/pref$$.dat
# New in c32a2
    echo "FITCHG"     >> $chmbuild/pref$$.dat
# Removed in c35a1    echo "SLVSLV"     >> $chmbuild/pref$$.dat
# Removed in c35a1    echo "LNTAB1"     >> $chmbuild/pref$$.dat
    echo "WCA"        >> $chmbuild/pref$$.dat
# New in c33a3
    echo "CHEMPERT"   >> $chmbuild/pref$$.dat
#    echo "CORSOL"     >> $chmbuild/pref$$.dat
#    echo "FEWMFC"     >> $chmbuild/pref$$.dat
#    echo "PBCUBES"    >> $chmbuild/pref$$.dat
    echo "PROTO"      >> $chmbuild/pref$$.dat
    echo "SMD"        >> $chmbuild/pref$$.dat
# New in c35a1
#    echo "ACTBOND"    >> $chmbuild/pref$$.dat
#    echo "COLFFT"     >> $chmbuild/pref$$.dat
    echo "COMP2"      >> $chmbuild/pref$$.dat
    echo "FACTS"      >> $chmbuild/pref$$.dat
    echo "LOOKUP"     >> $chmbuild/pref$$.dat
#    echo "MSCALE"     >> $chmbuild/pref$$.dat
    echo "RMD "       >> $chmbuild/pref$$.dat
    echo "RXNCONS"    >> $chmbuild/pref$$.dat
#    echo "ZEROM"      >> $chmbuild/pref$$.dat
####
    if ( $mpiset == 0 && $chm_host != 'ibmaixmp') \
       echo "TAMD"       >> $chmbuild/pref$$.dat
#---end of new feature keys
    if ( $qgamess == 1 ) then
      echo "GAMESS"     >> $chmbuild/pref$$.dat
    else if ( $qgamessuk == 1 ) then
      echo "GAMESSUK"   >> $chmbuild/pref$$.dat
    else if ( $qcadpac == 1 ) then
      echo "CADPAC"     >> $chmbuild/pref$$.dat
    else if ( $qsccdftb == 1 ) then
      echo "SCCDFTB"    >> $chmbuild/pref$$.dat
    else if ( $qqchem == 1 ) then
      echo "QCHEM"      >> $chmbuild/pref$$.dat
    else if ( $qmndo97 == 1 ) then
      echo "MNDO97"     >> $chmbuild/pref$$.dat
      echo "GHO"        >> $chmbuild/pref$$.dat
    else if ( $qsquantm == 1 ) then
      echo "SQUANTM"    >> $chmbuild/pref$$.dat
    else
      echo "QUANTUM"    >> $chmbuild/pref$$.dat
    endif
    echo "RUSH"     >> $chmbuild/pref$$.dat
  endif
endif
#
if ( $nih == 1 ) then
  echo "LONGLINE"    >> $chmbuild/pref$$.dat
  echo "NIH"         >> $chmbuild/pref$$.dat
  echo "SAVEFCM"     >> $chmbuild/pref$$.dat
  echo "SHAPES"      >> $chmbuild/pref$$.dat
  echo "SGLD"        >> $chmbuild/pref$$.dat
#
endif
#
if ( $tsri == 1 ) then
  echo "PMEPLSMA"   >> $chmbuild/pref$$.dat
  echo "IMCUBES"    >> $chmbuild/pref$$.dat
  echo "GENBORN"    >> $chmbuild/pref$$.dat
  echo "GBINLINE"   >> $chmbuild/pref$$.dat
  echo "GBSWIT"     >> $chmbuild/pref$$.dat
  echo "DMCONS"     >> $chmbuild/pref$$.dat
  echo "RGYCONS"    >> $chmbuild/pref$$.dat
endif
# polyrate control
if ( $polyrate ) echo "CHARMMRATE" >> $chmbuild/pref$$.dat
#
if ( $ensemble ) then
    echo "ENSEMBLE"    >> $chmbuild/pref$$.dat
endif
#
# ----------------
if ( $xreq ) then
  echo "XDISPLAY"   >> $chmbuild/pref$$.dat
else if ( $nodsp ) then
  echo "NODISPLAY"  >> $chmbuild/pref$$.dat
else
  echo "NOGRAPHICS" >> $chmbuild/pref$$.dat
endif
if ( $rng == 1 ) then
  echo "NEWRNG"     >> $chmbuild/pref$$.dat
endif
echo "END"          >> $chmbuild/pref$$.dat
#
if ( $stopmark == 2 ) then
  echo " "
  echo " install.com> Installation STOPs after creating "
  echo "              the default pref.dat and"
  echo "              the preprocessor prefx_$chm_host."
  echo " "
  mv $chmbuild/pref$$.dat $chmbuild/pref.dat
  exit 2
endif
#
if (! -e $chmbuild/pref.dat ) then
  # MF 03/2006
  # modify pref.dat according to flags in addprefdat/delprefdat

  if ( $#addprefdat > 0 ) then
     foreach add ( $addprefdat )
       if ( { ( grep ^${add}'$' $chmbuild/pref$$.dat >& /dev/null ) } ) then
          echo $add already exists in pref.dat
       else 
          sed -e '/^END$/'i${add} $chmbuild/pref$$.dat > $chmbuild/pref$$_tmp.dat
          mv $chmbuild/pref$$_tmp.dat $chmbuild/pref$$.dat
       endif
     end
  endif

  if ( $#delprefdat > 0 ) then
     foreach del ( $delprefdat )
       grep -v ^${del}'$' $chmbuild/pref$$.dat > $chmbuild/pref$$_tmp.dat
       mv $chmbuild/pref$$_tmp.dat $chmbuild/pref$$.dat
     end
  endif

  mv $chmbuild/pref$$.dat $chmbuild/pref.dat
else
  echo " install.com> pref.dat already exists and contains"
  echo "              the following preprocessor directives."
  echo " "
  cat  $chmbuild/pref.dat
  echo " "
  echo " install.com> The existing pref.dat will be used in this"
  echo "              installation."
  /bin/rm -f $chmbuild/pref$$.dat
endif

# Modify Makefile for PARCMD in pref.dat
if ( $chmhost == gnu ) then
  if ( 1 == `grep PARCMD $chmbuild/pref.dat | wc -l` ) then
    if ( 1 != `grep parcmd $chmbuild/Makefile_$chmhost | wc -l` ) then
      sed -e '8s@cc @cc -Dparcmd @' \
        $chmbuild/Makefile_$chmhost > $chmbuild/Makefile_$$
      /bin/mv $chmbuild/Makefile_$$ $chmbuild/Makefile_$chmhost
    endif
  endif
endif

#
# prepare the host platform dependent Makefile
# 08-AUG-92, Always re-generate Makefile, ydw.
sed -e 2s@rootdir@$chmroot@ $chmbuild/Makefile_$chm_host > Makefile_$$
#
# clbiii mods
# Rework of MPI installation procedures to modify machine specific Makefiles.
# Changes introduced below produce following outcome w/ following input:
#
# install.com machine size M
# produces => MSGLIB = -Lmpi -lmpi
#
# install.com machine size M mpich
# produces => MSGLIB = -Lmpi -lfmpich -lmpich
#
# install.com machine size M lammpi
# produces => MSGLIB = -Lmpi -llamf77mpi -lmpi -llam
#
# install.com machine size M mpispecial
# produces => echo "Enter load line arguments for MPI library linking"
#             echo -n ">> "
#             set linkmpi = "$<"
#	      echo "Adding to load line for linking: -Lmpi "$linkmpi
#	      echo "MSGLIB = -Lmpi "$linkmpi >> sed.tmp_$$
#
# Also, modification introduced to result of query about where include and
# libraries are kept, added linking of *.so as well as *.a to mpi/ directory.
#
if ( $ensemble == 1 ) then
	echo "10a\" > sed.tmp_$$
	echo "MSGLIB = -Lmpi -lmpi" >> sed.tmp_$$
	mv Makefile_$$ Makefile.tmp_$$
    	sed -f sed.tmp_$$ Makefile.tmp_$$ > Makefile_$$
    	/bin/rm sed.tmp_$$ Makefile.tmp_$$
endif
#
if ( $mpiset == 1 ) then
    set mpigeneral = 0
#
#  Prepare for Makefile modifications
    mv Makefile_$$ Makefile.tmp_$$
    echo "10a\" > sed.tmp_$$
#
    if ( ! ( $mpich == 1 || $lammpi == 1 || $mpispecial == 1 || $scali == 1 ) ) then
	set mpigeneral = 1
    endif
    if ( $mpigeneral == 1 ) then
	echo "MSGLIB = -Lmpi -lmpi" >> sed.tmp_$$
#
    else
	if ( $mpich == 1 ) then
	    echo "MSGLIB = -Lmpi -lfmpich -lmpich -lpthread" >> sed.tmp_$$
	else if ( $lammpi == 1 ) then
	    echo "MSGLIB = -Lmpi -llamf77mpi -lmpi -llam" >> sed.tmp_$$
	else if ( $scali == 1 ) then
	    echo "MSGLIB = -Lmpi -lfmpi -lmpi" >> sed.tmp_$$
# scasci and scirtl are  no longer needed with Scali MPI Connect (v4)
#	    echo "MSGLIB = -Lmpi -lfmpi -lmpi -lscasci -lscirtl" >> sed.tmp_$$
	else
	    if ($?MPI_SPECIAL == 0) then
  	       echo "Enter load line arguments for MPI library linking"
	       echo -n ">> "
	       set linkmpi = "$<"
	       setenv MPI_SPECIAL $linkmpi
            else 
	       set linkmpi = $MPI_SPECIAL
	    endif
	    echo "Adding to load line for linking: -Lmpi "$linkmpi
	    echo "MSGLIB = -Lmpi "$linkmpi >> sed.tmp_$$
	endif
    endif
    sed -f sed.tmp_$$ Makefile.tmp_$$ > Makefile_$$
    /bin/rm sed.tmp_$$ Makefile.tmp_$$
endif
#
# PS check??
if( $chm_host == gnu && ( $mpiset == 1 || $ensemble ==  1 ) && $scali == 0) then
    mv Makefile_$$ Makefile.tmp_$$
    sed -e 's/g77/mpif90 -Impi/g' -e 's/gcc/mpicc/g' \
        -e 's/ fort/ mpif90 -fc=fort -Impi/g' -e 's/ccc/mpicc -cc=ccc/g' \
        -e 's/ifc/mpif90 -Impi/g' \
        -e 's/gfortran/mpif90 -Impi/g' \
	-e 's/ifort/mpif90 -Impi/g' \
        -e 's/pathf90/mpif90 -Impi/g' \
        -e 's/pgf95/mpif90 -Impi/g' < Makefile.tmp_$$ > Makefile_$$
    /bin/rm Makefile.tmp_$$
else if( $chm_host == hpitanium && $mpiset == 1 ) then
    mv Makefile_$$ Makefile.tmp_$$
    sed -e 's/f90/mpif90 -Impi/g' -e 's/cc/mpicc/g' \
        < Makefile.tmp_$$ > Makefile_$$
    /bin/rm Makefile.tmp_$$
else if( $chm_host == itanium && $mpiset == 1 ) then
    mv Makefile_$$ Makefile.tmp_$$
    sed -e 's/ifort/mpif90 -Impi/g' -e 's/icc/mpicc/g' \
        < Makefile.tmp_$$ > Makefile_$$
    /bin/rm Makefile.tmp_$$
 else if( $chm_host == g95 && ( $mpiset == 1 || $ensemble ==  1 )) then
     mv Makefile_$$ Makefile.tmp_$$
     sed  -e 's/ g95/ mpif90 -Impi/g'  < Makefile.tmp_$$ > Makefile_$$
     /bin/rm Makefile.tmp_$$
endif
#
# In case pref.dat is old
set ppvmset = 0
if ( 1 == `grep PVM $chmbuild/pref.dat | wc -l` ) set ppvmset = 1
#
if ( ( $pvmset == 1 || $ppvmset == 1 ) && ( $chm_host != 'alphamp' ) ) then
   mv Makefile_$$ Makefile.tmp_$$
   sed -e 's@$(GLIB)@$(GLIB) -Wl,-Lpvm -lfpvm3 -lpvm3@' \
                      Makefile.tmp_$$ > Makefile_$$
   /bin/rm Makefile.tmp_$$
endif
if ( ( $pvmset == 1 || $ppvmset == 1 ) && ( $chm_host == 'alphamp' ) ) then
   mv Makefile_$$ Makefile.tmp_$$
   sed -e 's@$(GLIB)@$(GLIB) -ldpvm -lrt -lots@' \
                      Makefile.tmp_$$ > Makefile_$$
   /bin/rm Makefile.tmp_$$
endif

# remove static flag if dynamic linking requested
if ( $dynamic == 1 ) then
   mv Makefile_$$ Makefile.tmp_$$
   sed -e 's/-static//g' Makefile.tmp_$$ > Makefile_$$
   /bin/rm Makefile.tmp_$$
endif

mv Makefile_$$ $chmbuild/Makefile
#
# cleaning and informative message out
echo " "
echo " install.com> Phase 2 completed."
#
#-----------------------------------------------------------------------
#
phase3:
# (3.1) Process source and include files
# (3.2) Compile and build the library for each module
# (3.3) Link to produce the executable.
#
echo " "
echo " install.com> Processing CHARMM source on $chm_host..."
echo " "
#
# make CHARMM
if ($?chmhost == 0) then
  echo " "
  echo " install.com> Environment variable chmhost is not defined."
  exit 1
endif
#
if ( $?chmbuild == 0 ) then
  echo " "
  echo " install.com> Environment variable chmbuild is not defined."
  exit 1
endif
pushd $chmbuild >> /dev/null
#
if ( $?chmtool == 0 ) then
  echo " "
  echo " install.com> Environment variable chmtool is not defined."
  exit 1
endif
#
if ($?chmsrc == 0 ) then
  echo " "
  echo " install.com> Environment variable chmsrc is not defined."
  exit 1
endif
#
# PVM links
if ($pvmset == 1 ) then
   /bin/rm -rf pvm
   mkdir pvm
   echo "Enter the absolute path to the pvm include files (pvm3.h and fpvm3.h)"
   echo -n ">> "
   set incpath = $<
   if (! -e $incpath) then
      echo "Error: can't find directory "$incpath
      exit -1
   endif
   cd pvm
   ln -s $incpath/*.h .
   cd ..
   echo "Enter the absolute path to the pvm lib files (lib?pvm3.a)"
   echo -n ">> "
   set libpath = $<
   if (! -e $libpath) then
      echo "Error: can't find directory "$libpath
      exit -1
   endif
   cd pvm
   ln -s $libpath/*.a .
   cd ..
   #MPI links
else if ( $chm_host == ibmaixmp ) then
   echo " "
   echo "Making links to mpi include files in build/ibmaixmp/mpi/"
   echo "If these links do not work, ask admin where to find mpif.h and libs"
   echo " "
   /bin/rm -rf mpi
   mkdir mpi
   if ( $ibm64 == 1) then
      set incpath = /usr/lpp/ppe.poe/include/thread64
   else
      set incpath = /usr/lpp/ppe.poe/include/thread
   endif
   if (! -e $incpath) then
      echo "Error: can't find directory "$incpath
      exit -1
   endif
   cd mpi
   ln -s $incpath/*.h .
   cd ..
else if ($mpiset == 1 && $chmhost == itanium ) then
   echo "Using mpif90 for compile"
else if ($mpiset == 1 || $ensemble == 1 ) then
    if( $?MPI_HOME ) then
	if ( -d $MPI_HOME/include ) then
	    setenv MPI_INCLUDE $MPI_HOME/include
	else
	    echo "MPI_HOME is set but include dir does not exist"
	endif
	if ( -d $MPI_HOME/lib ) then
	    setenv MPI_LIB $MPI_HOME/lib
	else
	    echo "MPI_HOME is set but lib dir does not exist"
	endif
    endif
   /bin/rm -rf mpi
   mkdir mpi
   if ($?MPI_INCLUDE == 0) then
      echo "Enter the absolute path to the mpi include files (mpi.h, etc.)"
      echo -n ">> "
      set incpath = $<
      setenv MPI_INCLUDE $incpath
   else
      set incpath = $MPI_INCLUDE
   endif
   setenv MPI_INCLUDE $incpath
   if (! -e $incpath) then
      echo "Error: can't find directory "$incpath
      exit -1
   endif
   cd mpi
   ln -s $incpath/*.h .
   cd ..
   if ($?MPI_LIB == 0) then
      echo "Enter the absolute path to the mpi lib files (e.g., libmpi.a(so))"
      echo -n ">> "
      set libpath = $<
      setenv MPI_LIB $libpath
   else
      set libpath = $MPI_LIB
   endif
   setenv MPI_LIB $libpath
   if (! -e $libpath) then
      echo "Error: can't find directory "$libpath
      exit -1
   endif
   cd mpi
   ln -s $libpath/*.a .
   ln -s $libpath/*.so .
   cd ..
endif
#
/bin/rm -rf fcm
ln -s $chmsrc/fcm fcm
if ( $status != 0 ) exit -1
setenv MAKELIM 1
#
# have to create empty archives if they don't exist
if ($?chmlib == 0 ) then
  echo " "
  echo " install.com> Environment variable chmlib is not defined."
  exit 1
endif
#
pushd $chmsrc >> /dev/null
if ($chm_host == sgi ) then
  set mdlist = `/bin/ls | sed '/fcm/d' | sed '/charmm/d'`
else if ( $chm_host == t3e ) then
  set mdlist = `/bin/ls -c | sed '/fcm/d' | sed '/charmm/d'`
else
  set mdlist = `/bin/ls -1 | sed '/fcm/d' | sed '/charmm/d'`
endif
popd >> /dev/null
#
if (! -e $chm_host.log) then
   echo "CHARMM Build on $chm_host" `date` > $chm_host.log
else
   echo "CHARMM Build on $chm_host" `date` >> $chm_host.log
endif
#
foreach module ( $mdlist )
  if (! -e $chmlib/$module.a ) $AR_COMMAND $chmlib/$module.a
end
if (! -e $chmlib/stamp)  touch $chmlib/stamp
#
#
if ( 1 == `grep GAMESSUK pref.dat | wc -l` ) then
  set gamess = '-f guk.mk'

  #
  #  Select the correct version of the interface code
  #  to be used in GAMESS-UK build
  #
  setenv CHMGUK_VERSION 5

  # these flags are used help GAMESS-UK find the correct include files
  # and will also influence whether the -fno-second-underscore flag is used 
  # when GAMESS-UK is built  

  if ( $mpich == 1 ) then
    setenv MPIVERSION mpich
  else if ( $lammpi == 1 ) then
    setenv MPIVERSION lam
  else if ( $scali == 1 ) then
    setenv MPIVERSION scali
  else
    setenv MPIVERSION ""
  endif
 
  if ( $chm_host == gnu ) then
    if ( $f77 == 1 ) then
      setenv F77 absoft
    else if ( $f2c == 1 ) then
      # this will need work
      setenv F77 f2c
    else if ( $g77 == 1 ) then
      setenv F77 g77
    else if ( $ifc == 1 ) then
      setenv F77 ifc
    else if ( $efc == 1 ) then
      setenv F77 efc
    else if ( $pgf95 == 1 ) then
      setenv F77 pgf95
    else if ( $g95 == 1 ) then
      setenv F77 g95
    else if ( $gfortran == 1 ) then
      setenv F77 gfortran
    else if ( $cfort == 1 ) then
      # this will need work
      setenv F77 fort
    else
      setenv F77 gfortran
    endif
  endif

else if ( 1 == `grep GAMESS pref.dat | wc -l` ) then
 set gamess = '-f gamess.mk'
 if (! -e $chmtool/actvte.x_$chm_host ) then
   if ( $chm_host == gnu ) then
    $forcom -o $chmtool/actvte.x_$chm_host $chmtool/actvte.f
   else if ( $chm_host == t3e ) then
    f90 -o $chmtool/actvte.x_$chm_host $chmtool/actvte-t3e.f
   else
    f77 -o $chmtool/actvte.x_$chm_host $chmtool/actvte.f
   endif
 endif
else
 set gamess = ''
endif
#
#
if ( 1 == `grep CADPAC pref.dat | wc -l` ) then
 set cadpac = '-f cadpac.mk'
 if ( $cfort == 1 && $chmhost == gnu ) then
  if ( 0 == `grep DGNUALPHA $chmbuild/cadpac.mk | wc -l` ) then
   mv -f $chmbuild/cadpac.mk $chmbuild/cadpac.mk.$$
   sed -e 's/DEFS = /DEFS = -DGNUALPHA /' \
      $chmbuild/cadpac.mk.$$ > $chmbuild/cadpac.mk
   /bin/rm -f $chmbuild/cadpac.mk.$$
  endif
 else if ( $cfort == 0 ) then
  mv -f $chmbuild/cadpac.mk $chmbuild/cadpac.mk.$$
  sed -e 's/-DGNUALPHA //g' \
      $chmbuild/cadpac.mk.$$ > $chmbuild/cadpac.mk
   /bin/rm -f $chmbuild/cadpac.mk.$$
 endif
else
 set cadpac = ''
endif
#
if ( 1 == `grep SCCDFTB pref.dat | wc -l` ) then
 set sccdftb = '-f sccdftb.mk -f sccdftbint.mk'
# Also process the include file
 echo "Preparing the include file for SCCDFTB ...... "
# $chmtool/ratfor.$chm_host < $chmsrc/sccdftbint/sccdftbsrc/maxima.h > $chmbuild/maxima.inc
 cp $chmsrc/sccdftbint/sccdftbsrc/maxima.h $chmbuild/
 cp $chmsrc/sccdftbint/sccdftbsrc/maxima.inc $chmbuild/
# cp $chmtool/ratfor.$chm_host $chmbuild/ratfor
else
 set sccdftb = ''
endif

#
if ( 1 == `grep MNDO97 pref.dat | wc -l` ) then
 set mndo97 = '-f mndo97.mk'
else
 set mndo97 = ''
endif

#
if ( 1 == `grep SQUANTM pref.dat | wc -l` ) then
 set squantm = '-f squantm.mk'
else
 set squantm = ''
endif

# PJ 06/2005
if (1 == `grep PIPF pref.dat |wc -l`) then
   set pipf = '-f pipf.mk'
else
   set pipf = ''
endif

#
if ( 1 == `grep MBOND pref.dat | wc -l` ) then
 set mbond = '-f mbond.mk -f moldyn.mk'
 setenv MBOND Y
else
 set mbond = '-f mbond.mk'
 sed -e '/moldyn.a/d' Makefile > Makefile.tmp$$
 mv Makefile.tmp$$ Makefile
endif
#
#
if ( 1 == `grep NOGRAPHICS pref.dat | wc -l` ) then
 sed -e '/graphics.a/d' Makefile > Makefile.tmp$$
 mv Makefile.tmp$$ Makefile
 set graphics = ' '
else
 set graphics = '-f graphics.mk'
endif

# Setup flucq and cadpac makefiles for FlucQ (if enabled)
if ( 1 == `grep FLUCQ pref.dat | wc -l` ) then
 set flucq = '-f flucq.mk'
 awk '/cadint/ { print "	$(LIB)/flucq.a \\" } \
      /./      {print $0}' \
                Makefile > Makefile.tmp$$
 mv Makefile.tmp$$  Makefile
 if ( 1 == `grep CADPAC pref.dat | wc -l` ) then
  if ( 0 == `grep DFLUCQ $chmbuild/cadpac.mk | wc -l` ) then
   mv -f $chmbuild/cadpac.mk $chmbuild/cadpac.mk.$$
   sed -e 's/DEFS = /DEFS = -DFLUCQ /' \
      $chmbuild/cadpac.mk.$$ > $chmbuild/cadpac.mk
   /bin/rm -f $chmbuild/cadpac.mk.$$
  endif
 endif
else
 set flucq = ''
 if ( 1 == `grep CADPAC pref.dat | wc -l` ) then
  mv -f $chmbuild/cadpac.mk $chmbuild/cadpac.mk.$$
  sed -e 's/-DFLUCQ //g' \
      $chmbuild/cadpac.mk.$$ > $chmbuild/cadpac.mk
  /bin/rm -f $chmbuild/cadpac.mk.$$
 endif
endif

# Setup EMAP processing
if ( 1 == `grep EMAP pref.dat | wc -l` ) then
 set emapmk = '-f emap.mk'
 awk '/dynamc/ { print "	$(LIB)/emap.a \\" } \
      /./      {print $0}' \
                Makefile > Makefile.tmp$$
 mv Makefile.tmp$$  Makefile
else
 set emapmk = ''
endif

# Check for socket compile - some machines don't support this
# include only when really needed
if ( 1 == `grep SOCKET pref.dat | wc -l` ) then
     sed -e 's@cc @cc -Dchmsocket @' \
      Makefile > Makefile.tmp$$
 mv Makefile.tmp$$  Makefile
endif

#
# POLYRATE installation control
#
#  The following environment varibles should have benn set (see documentation)
#
#       pr     = POLYRATE programm directory
#       crate  = CRATE utility directory
#
#  The script file install_cr.com and the source files of polyrate 
#  are provided by UofM
#
if ( $polyrate == 1 ) then
   echo " install_cr.com >  run the CRATE utility"
   echo "                   to copy the source code files of POLYRATE"
   if (! $?crate) setenv crate $chmsrc/prate/crate
   if (! $?pr)    setenv pr    $chmsrc/prate/polyrate
   $crate/install_cr.com
   echo " install.com> copy polyrate common blocks into the build directory"
   /bin/cp $chmsrc/prate/param.inc $chmbuild/.
   /bin/cp $chmsrc/prate/percon.inc $chmbuild/.
   /bin/cp $chmsrc/prate/common.inc $chmbuild/.
   /bin/cp $chmsrc/prate/charmmrate.inc $chmbuild/.
   set prate = '-f prate.mk'
# modify Makefile to include prate.a in the LIB list
   awk '/rxncor/ { print "	$(LIB)/prate.a \\" } \
        /./      {print $0}' \
                 $chmbuild/Makefile > $chmbuild/Makefile_$$
   /bin/mv $chmbuild/Makefile_$$ $chmbuild/Makefile
else
   set prate = ''
endif
#

if ( ! $?MAKE_COMMAND ) then
  setenv MAKE_COMMAND make
endif

set go_make = "$MAKE_COMMAND -f Makefile -f charmm.mk -f adumb.mk -f cadint.mk"
set go_make = "$go_make -f cff.mk -f correl.mk -f dimb.mk -f dynamc.mk"
set go_make = "$go_make -f energy.mk -f gamint.mk -f gukint.mk"
set go_make = "$go_make -f gener.mk -f image.mk -f io.mk -f machdep.mk "
set go_make = "$go_make -f mc.mk -f mmff.mk -f manip.mk -f minmiz.mk"
set go_make = "$go_make -f misc.mk -f mndint.mk -f molvib.mk -f mscale.mk"
set go_make = "$go_make -f nbonds.mk -f pert.mk -f quantum.mk -f rxncor.mk"
set go_make = "$go_make -f shapes.mk -f solvation.mk -f util.mk "
set go_make = "$go_make -f vibran.mk -f zerom.mk"

set go_make = "$go_make $cadpac $emapmk $flucq $gamess $graphics $mbond"
set go_make = "$go_make $mndo97 $squantm $pipf $prate $sccdftb"

if( $?nolog ) then
   $go_make 
else
   $go_make >& new.log
   cat new.log >> $chm_host.log
endif
#
#
if ( -x charmm.exe ) then
  mv charmm.exe $chmexec/charmm
  echo " "
  echo " install.com> CHARMM Installation is completed."
  echo "              The CHARMM executable is $chmexec/charmm."
else
  echo " "
  echo " install.com> The CHARMM executable"
  echo "              $chmexec/charmm is NOT produced."
  echo "              Check $chmbuild/$chm_host.log"
  echo "              for installation errors."
endif
#
popd >> /dev/null
echo " "
echo " install.com> Phase 3 completed."
#
# clean up
#
date
exit
